function alertViewController() {
    var state = null;
    var $alertView = $('#modal');
    var modalTitle = document.getElementById("modalTitle");
    var modalBody = document.getElementById("modalBody");
    var modalButtons = document.getElementById("modalButtons");
    var actionButton = document.getElementById("actionButton");
    var cancelButton = document.getElementById("cancelButton");

    this.displayCredits = function(){
        cancelButton.innerHTML = "Done";
        modalTitle.innerHTML = "Game Credits";
        modalBody.innerHTML = "<span style='font-size:0.9em'><span class='red'>Jon Richardson:</span> Developer, Editor<br/><span class='red'>Bryan Richmond:</span> Writer<br/><span class='red'>Paulo D'Antonio:</span> Illustrator<br/><br/>The Doom Beneath is based on Bryan Richmond's \"Palace of Chained Souls\". <br/><br/>This game uses many sounds from freesound. For the list: www.thedoombeneath.com/sounds</span>";
        $alertView.modal('show');
        actionButton.style.display = "none";
    }

    this.displayCharacterStatus = function(){
//        console.log("displaying character status");
        cancelButton.innerHTML = "Done";
        modalTitle.innerHTML = "Character Details";
        var skillsPrompt = "";
        var companionsPrompt = "";
        var armorPrompt = "";
        var combatFlags = "";
        for (var i=0;i<playerCharacter.skills.length;i++){
            skillsPrompt=skillsPrompt+"<li>"+playerCharacter.skills[i]+"</li>";
        }
        skillsPrompt = "<ul>"+skillsPrompt+"</ul>";

        if ('companions' in playerCharacter && playerCharacter.companions.length!=0){
            for (var i=0;i<playerCharacter.companions.length;i++){
                companionsPrompt=companionsPrompt+"<li>"+playerCharacter.companions[i][0]+"</li>";   
            }
            companionsPrompt = "Your companions:<ul>"+companionsPrompt+"</ul>"    
        } else {
            companionsPrompt = "<p>You have no companions.</p>"
        }
        
        if ('armor' in playerCharacter.details && playerCharacter['details']['armor']!=null){
            armorPrompt = "You are protected by:<ul><li>a "+playerCharacter.details.armor.name+"</li></ul>";
        } else {
            armorPrompt = "<p>You have no arcane protection.</p>"
        }
        modalBody.innerHTML = "Your skills:"+skillsPrompt+""+companionsPrompt+""+armorPrompt
        //You have the following skills:
        //You have the following companions:
        //You are protected by: nothing
        $alertView.modal('show');
        actionButton.style.display = "none";
    }

    this.displayWieldedDetails = function(){
//        console.log("displayWieldedDetails");
        cancelButton.innerHTML = "Done";
        var attackPhrase = "";
        if ('weapon' in playerCharacter.details && playerCharacter['details']['weapon']!=null){
            modalTitle.innerHTML = "Wielding: "+playerCharacter.details.weapon.name;
            actionButton.style.display = "inline-block";
            actionButton.innerHTML = "Remove"
            actionButton.onclick = function(){
                    playerCharacter.details.weapon = null;
                    if ($combatScreen.hasClass("visiblePage")){
                        combatController.updateCombatChoiceUI(playerCharacter.details);
                    } else {
                        "combat screen not visible, not updating combat choice UI"
                    }
                    hudWielded.src = "images/fist.png";
                    $alertView.modal('hide');
                    actionButton.onclick=null;
            }
            if (playerCharacter.details.weapon.skill in playerCharacter.details.skills){
                attackPhrase = "<li style='' class='red'>bonus from "+characterGenerator.skillLookup[playerCharacter.details.weapon.skill]['name'].toLowerCase()+"</li>"+playerCharacter.details.weapon.attackPhrase;
            }else {
                attackPhrase = playerCharacter.details.weapon.attackPhrase;
            }
            modalBody.innerHTML = "In combat, you will attack with " +playerCharacter.details.weapon.name.toLowerCase()+".<br/><br/>Attack Details:"+"<ul>"+attackPhrase+"</ul>";
        } else {
            attackPhrase = "<li>basic unarmed attack</li>";
            actionButton.style.display = "none";
            modalTitle.innerHTML = "You Hold No Weapon";
            if ('Brawling' in playerCharacter.details.skills){
//                console.log("Skilled");
                attackPhrase = "<li style='' class='red'>bonus from brawling</li>"+attackPhrase;
            }else {
//                console.log("UnSKILLED");
                //attackPhrase = "<li style='' class=''>bonus from brawling</li>"+attackPhrase;
            }
            modalBody.innerHTML = "You are unarmed. In combat, you will attack with your fists and the brawling skill. <br/><br/>"+"Attack Details:<ul>"+attackPhrase+"</ul>";
        }
        //You aren't wielding anything -- your attacks are unarmed.
        //Weapon details
        //Weapon description

        $alertView.modal('show');
    }

    this.displayEquipAlert = function(item) {
    	actionButton.style.display = "inline-block";
        actionButton.innerHTML = "Wield"
    	cancelButton.innerHTML = "Stash"
        
        modalTitle.innerHTML = "Wield "+item[0]+"?";
        modalBody.innerHTML = "You just picked up an item that can be wielded. Wield item?"
        $alertView.modal('show');
        actionButton.onclick = function(){
        	playerCharacter.details.weapon = item.arpgData;
            hudWielded.src = "images/"+playerCharacter.details.weapon.imageFull;
//            console.log("!!!!checking combat choice UI");
            
        	$alertView.modal('hide');
        	actionButton.onclick=null;
            audioPlayer.playAudio("0,"+playerCharacter.details.weapon.useSound+",0");
        }
    }

    this.displayInventory = function() {
        var attackPhrase = "";
        inventoryList.style.display="block";
        cancelButton.innerHTML = "Done";
//        console.log("inventoryList");
//        console.log(inventoryList.innerHTML);
//        console.log(inventoryList.childNodes.length);
        actionButton.style.display = "none";
        if (inventoryList.childNodes.length!=0){
            modalTitle.innerHTML = "You have these things stashed away:";
            modalBody.innerHTML = "";
        } else {
            
            if ('weapon' in playerCharacter.details && playerCharacter['details']['weapon']!=null){
            modalTitle.innerHTML = "Wielding: "+playerCharacter.details.weapon.name;
            actionButton.style.display = "inline-block";
            actionButton.innerHTML = "Remove";
            actionButton.onclick = function(){

                    playerCharacter.details.weapon = null;
                    if ($combatScreen.hasClass("visiblePage")){
                        combatController.updateCombatChoiceUI(playerCharacter.details);
                    } else {
                        "combat screen not visible, not updating combat choice UI"
                    }
                    
                    hudWielded.src = "images/fist.png";
                    $alertView.modal('hide');
                    actionButton.onclick=null;
            }
            if (playerCharacter.details.weapon.skill in playerCharacter.details.skills){
                attackPhrase = "<li style='' class='red'>bonus from "+characterGenerator.skillLookup[playerCharacter.details.weapon.skill]['name'].toLowerCase()+"</li>"+playerCharacter.details.weapon.attackPhrase;
            }else {
                attackPhrase = playerCharacter.details.weapon.attackPhrase;
            }
            modalBody.innerHTML = "In combat, you will attack with " +playerCharacter.details.weapon.name.toLowerCase()+".<br/><br/>Attack Details:"+"<ul>"+attackPhrase+"</ul>";
            inventoryList.style.display="none";
        } else {
            var attackPhrase = "<li>basic unarmed attack</li>";
            actionButton.style.display = "none";
            modalTitle.innerHTML = "You Have No Items";
            if ('Brawling' in playerCharacter.details.skills){
//                console.log("Skilled");
                attackPhrase = "<li style='' class='red'>bonus from brawling</li>"+attackPhrase;
            }else {
//                console.log("UnSKILLED");
                //attackPhrase = "<li style='' class=''>bonus from brawling</li>"+attackPhrase;
            }
            modalBody.innerHTML = "You have no items and you are unarmed! In combat, you will attack with your fists and the brawling skill. <br/><br/>"+"Attack Details:<ul>"+attackPhrase+"</ul>";
        }
        }
        
        
        $alertView.modal('show');
        $alertView.on('hidden.bs.modal', function() {
            inventoryList.style.display="none";
            $alertView.off('hidden.bs.modal');
        });
    }

    this.displaySaveAlert = function(item) {
        if (!$combatScreen.hasClass('visiblePage')){
            actionButton.style.display = "inline-block";
            cancelButton.innerHTML = "Cancel"
            actionButton.innerHTML = "Set"
            modalTitle.innerHTML = "Set Bookmark?";
            modalBody.innerHTML = "Bookmarking this page will allow you to return here should you die. Beware: only one page may be bookmarked at a time!"
            $alertView.modal('show');
            actionButton.onclick = function(){
                setRecord("savedGame", currentGame);
                $alertView.modal('hide');
                actionButton.onclick=null;
                audioPlayer.playAudio("0,"+"Reading-02"+",0");
                showAlert("Bookmark set!");
            }
        } else {
            cancelButton.innerHTML = "Cancel";
            actionButton.style.display = "none";
            modalTitle.innerHTML = "Unable To Bookmark";
            modalBody.innerHTML = "You aren't able to bookmark your page while fighting!"
            $alertView.modal('show');
            actionButton.style.display = "none";
        }
        
    }

    this.displayConsumeAlert = function(item) {
        cancelButton.innerHTML = "Stash";
        modalTitle.innerHTML = "New Consumable Item";
        modalBody.innerHTML = "You just picked up an item that can be consumed to restore health. You can do that from your stashed items!"
        $alertView.modal('show');
        actionButton.style.display = "none";
    }


    this.displayUnconsciousAlert = function() {
        cancelButton.innerHTML = "Okay";
        modalTitle.innerHTML = "You Can't Do That";
        modalBody.innerHTML = "You are unconscious and unable to move!"
        $alertView.modal('show');
        actionButton.style.display = "none";
    }

    this.displayBookmarkAlert = function(item) {
        //combatB1.innerHTML = '<img class="combatChoiceIcon" src="images/brawlingico.png"/> Slug';
        // actionButton.style.display = "inline-block";
        // cancelButton.innerHTML = "Cancel";
        // modalTitle.innerHTML = "Wield "+item[0]+"?";
        // modalBody.innerHTML = "You just picked up an item that can be wielded. Wield item?"
        // $alertView.modal('show');
        // actionButton.onclick = function(){
        //     playerCharacter.details.weapon = item.arpgData;
        //     hudWielded.src = "images/"+playerCharacter.details.weapon.imageThumb;
        //     combatB1.innerHTML = '<img class="combatChoiceIcon" src="images/'+playerCharacter.weapon.imageThumb+'"/> Attack';
        //     //update attackIcon
        //     $alertView.modal('hide');
        //     actionButton.onclick=null;
        //     audioPlayer.playAudio("0,"+playerCharacter.details.weapon.useSound+",0");
        // }
    }

    this.showInventoryAlert = function(item){
//        console.log("showInventoryAlert");
        var attackPhrase = "";
        $alertView.on('hidden.bs.modal', function() {
             $alertView.off('hidden.bs.modal');

    	if ('arpgData' in item){
    		modalTitle.innerHTML = item[0];
        	
            

        	if (item.arpgData.itemType == "weapon"){

                modalBody.innerHTML = item[2]+" This item can be wielded.<br/>";
                actionButton.style.display = "inline-block";
                cancelButton.innerHTML = "Back"
                

                if ('weapon' in playerCharacter.details && playerCharacter.details.weapon!=null && playerCharacter.details.weapon.name == item.arpgData.name){
                    actionButton.innerHTML = "Remove";
                    modalTitle.innerHTML = "Wielding: "+modalTitle.innerHTML;
                    actionButton.onclick = function(){
                        playerCharacter.details.weapon = null;
                        if ($combatScreen.hasClass("visiblePage")){
                            combatController.updateCombatChoiceUI(playerCharacter.details);
                        } else {
                            "combat screen not visible, not updating combat choice UI"
                        }
                        
                            hudWielded.src = "images/fist.png";
                            $alertView.modal('hide');
                            actionButton.onclick=null;

                            attackPhrase = "<li>basic unarmed attack</li>";
                            actionButton.style.display = "none";
                            inventoryList.style.display="none";
                            modalTitle.innerHTML = "You Are Now Unarmed";
                            if ('Brawling' in playerCharacter.details.skills){
//                                console.log("Skilled");
                                attackPhrase = "<li style='' class='red'>bonus from brawling</li>"+attackPhrase;
                            }else {
//                                console.log("UnSKILLED");
                                //attackPhrase = "<li style='' class=''>bonus from brawling</li>"+attackPhrase;
                            }
                            modalBody.innerHTML = "You are unarmed. In combat, you will attack with your fists and the brawling skill. <br/><br/>"+"Attack Details:<ul>"+attackPhrase+"</ul>";
                    }

                    if (playerCharacter.details.weapon.skill in playerCharacter.details.skills){
                        attackPhrase = "<li style='' class='red'>bonus from "+characterGenerator.skillLookup[playerCharacter.details.weapon.skill]['name'].toLowerCase()+"</li>"+playerCharacter.details.weapon.attackPhrase;
                    }else {
                        attackPhrase = playerCharacter.details.weapon.attackPhrase;
                    }
                    modalBody.innerHTML = "In combat, you will attack with " +playerCharacter.details.weapon.name.toLowerCase()+".<br/><br/>Attack Details:"+"<ul>"+attackPhrase+"</ul>";


                } else {
                    if (item.arpgData.skill in playerCharacter.details.skills){
                        attackPhrase = "<li style='' class='red'>bonus from "+characterGenerator.skillLookup[item.arpgData.skill]['name'].toLowerCase()+"</li>"+item.arpgData.attackPhrase;
                    }else {
                        attackPhrase = item.arpgData.attackPhrase;
                    }
                    modalBody.innerHTML = modalBody.innerHTML+"<br/>Attack Details:"+"<ul>"+attackPhrase+"</ul>";

                    actionButton.innerHTML = "Wield"
                    actionButton.onclick = function(){
                        playerCharacter.details.weapon = item.arpgData;
                        if ($combatScreen.hasClass("visiblePage")){
//                        console.log("!!!!udpating combat choice UI");
                            combatController.updateCombatChoiceUI(playerCharacter.details);
                        } else {
                            "!!!!combat screen not visible, not updating combat choice UI"
                        }
                        hudWielded.src = "images/"+playerCharacter.details.weapon.imageFull;
                        $alertView.off('hidden.bs.modal');
                        $alertView.modal('hide');
                        actionButton.onclick=null;
                        audioPlayer.playAudio("0,"+playerCharacter.details.weapon.useSound+",0");
                    }
                }

        	} else if (item.arpgData.itemType == "food"){
                modalBody.innerHTML = item[2]+"<br/><br>Using this item will consume it for health.";
                actionButton.style.display = "inline-block";
                actionButton.innerHTML = "Use"
                cancelButton.innerHTML = "Back"
                actionButton.onclick = function(){
                    var ARPGitem = itemGenerator.createItemWithTemplate(item[0]);
                    ARPGitem.action();
                    $alertView.modal('hide');
                    actionButton.onclick=null;
                }
            }
    	} else {
    		modalTitle.innerHTML = item[0];
        	modalBody.innerHTML = item[2];
        	actionButton.style.display = "none";
    		cancelButton.innerHTML = "Done"
    	}
        
            $alertView.on('hidden.bs.modal', function() {
                $alertView.off('hidden.bs.modal');
                alertViewController.displayInventory();
            });

            $alertView.modal('show');
        });

        $alertView.modal('hide');
    	
    }

    this.showSkillHelp = function(skill){
            
            switch (skill){
                        case "Brawling":
                            modalTitle.innerHTML = skill;
                            modalBody.innerHTML = "Used to clobber people at close range.  Provides a bonus to melee attacks.";             
                        break;
                        case "Marksmanship":
                          modalTitle.innerHTML = "Gunplay";
                          modalBody.innerHTML = "Reveals one important choice -- remember your trusty .44 magnum. Provides a bonus to shooting things.";
                        break;
                        case "Awareness":
                            modalTitle.innerHTML = skill;
                            modalBody.innerHTML = "Reveals choices requiring perception. Provides a bonus to AIM and COUNTER opportunities in combat.";
                        break;
                        case "Cunning":
                            modalTitle.innerHTML = skill;
                            modalBody.innerHTML = "Reveals choices requiring quick wits. Provides a bonus to BAIT and JAB opportunities in combat.";
                        break;
                        case "Fitness":
                            modalTitle.innerHTML = skill;
                            modalBody.innerHTML = "Reveals choices requiring athleticism. Provides a bonus to KICK and DODGE opportunities in combat.";
                        break;
                        case "Ancient Languages":
                         modalTitle.innerHTML = "Symbols";
                         modalBody.innerHTML = "Allows you to recognize glyphs and DECIPHER rituals with mysterious effects.";
                        break;
                        default:
                            
                        break;
                    }
            actionButton.style.display = "none";
            cancelButton.innerHTML = "Done"
            $alertView.modal('show');
    }
}