function character () {
//////    console.log('including character.js');
    this.name = null;
    this.class = null;
    this.target = null;
    this.unconscious = false;
    this.pronoun = null;

    this.strength = 0;
    this.dexterity = 0;
    this.constitution = 0;
    this.intelligence = 0;
    this.willpower = 0;
    this.charisma = 0;

    this.stun = 0;
    this.wound = 0;
    this.mortal = 0;

    this.inventory = [];
    this.companions = [];
    this.weapon = null;
    this.armor = null;
    this.skills = [];
    this.sdesc = "";
  	this.actionCheck = 0;
  	this.actionsNum = 0;

    this.xp = 0;

    this.stunPercentLookup = ["","winded","winded","winded","woozy","woozy","woozy","dazed","dazed","dazed"];
    this.woundPercentLookup = ["scratched","scraped","scraped","bleeding","bleeding","hurt","hurt","wounded","wounded","wounded"];
    this.mortalPercentLookup = ["maimed","maimed","maimed","mangled","mangled","mangled","mortally wounded","mortally wounded","mortally wounded","mortally wounded"]

    this.initWithCharacter = function(character){
        for (var k in character) {
            this[k]=character[k];
        };
        return this;
    }



    this.getResMod = function (stat){
    	if (this[stat]<=4){
    		return -2;
    	} else if (this[stat]<=6){
    		return -2;
    	} else if (this[stat]<=10){
    		return 0;
    	} else if (this[stat]<=12){
    		return 1;
    	} else if (this[stat]<=14){
    		return 2;
    	} else if (this[stat]<=16){
    		return 3;
    	} else if (this[stat]<=18){
    		return 4;
    	} else if (this[stat]>=19){
    		return 5;
    	}
    }

    this.getUntrained = function (stat){
    	return Math.floor(this[stat]/2)
    }

    this.getCombatStatus = function (){
        if ('countering' in this){    
            if (this.countering==0){
                delete this.countering;
            }
        }
        if ('dodging' in this){
            if (this.dodging==0){
                delete this.dodging;
            }
        }
        
        var statusPhrase = null;
        if ('aiming' in this){
            
            if ('dodging' in this){
                if ('countering' in this){
                    statusPhrase = "aiming, dodging, and ready to counter!"
                } else {
                    statusPhrase = "aiming and dodging!"    
                }
            } else if ('countering' in this){
                statusPhrase = "aiming and ready to counter!"
            }else {
                statusPhrase = "aiming!"
            }
            
        } else if ('dodging' in this){
            if ('countering' in this){
                    statusPhrase = "dodging and ready to counter!"
            } else {
                    statusPhrase = "dodging!"
            }
        } else if ('countering' in this){
            statusPhrase = "ready to counter!"
        }

        if (statusPhrase){
            return "You are "+statusPhrase;
        } else {
            return "";
        }
    }

    this.getAssess = function(){
        //console.log("getting character assess!");
         var isUndead = false;
//////            //console.log("checking if undead!");
            if ('flags' in this){
                for (var i=0;i<this.flags.length;i++){
                    if (this.flags[i]=="undead"){
                        isUndead = true;
                    }
                }
            }
            
 
        var assessment = "";
        var stunPercent = Math.floor((this.stun/this.constitution)*10);
        var woundPercent = Math.floor((this.wound/this.constitution)*10);   
        var mortalPercent = Math.floor((this.mortal/(Math.floor(this.constitution/2)))*10);
        var stunPhrase = this.stunPercentLookup[stunPercent-1];
        var woundPhrase = this.woundPercentLookup[woundPercent-1];
        var mortalPhrase = this.mortalPercentLookup[mortalPercent-1];

        if (this==playerCharacter.details){
            hudStun.style.opacity = stunPercent/10;
            hudBloodPerm.src = "images/"+bloodSpatterLookup[woundPercent];
        }



        if (mortalPercent>=10){
//////            // console.log("mortalPercent>=10");
            if (!isUndead){
                    assessment = "surely DEAD";
                } else {
                    assessment = "slowly disintegrating"
                }


            
        } else if (woundPercent>=10){
//////            // console.log("woundPercent>=10");
            if (!isUndead){
                woundPhrase = "unconscious";    
            } else {
                woundPhrase = "in a pain trance"
            }
            


            assessment = woundPhrase;
            if (mortalPercent>0){
                mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                assessment = woundPhrase+" and "+mortalPhrase;
            } else {
                assessment = woundPhrase+" and "+this.woundPercentLookup[woundPercent-1];
            }
        } else if (stunPercent>=10){
//////             console.log("stunPercent>=10");
            if (!isUndead){
                stunPhrase = "unconscious";    
            } else {
                stunPhrase = "in a trance"
            }
            assessment = stunPhrase;
            if (woundPercent>0){
                woundPhrase = this.woundPercentLookup[woundPercent-1];
                assessment = stunPhrase+" and "+woundPhrase;
                if (mortalPercent>0){
                    mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                    assessment = stunPhrase+", "+woundPhrase+", and "+mortalPhrase;
                }
            } else if (mortalPercent>0){
                    mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                    assessment = stunPhrase+" and "+mortalPhrase;
            }
        } else if (stunPercent>2&&stunPercent<10){
//////            // console.log("stunPercent>2&&stunPercent<10");
            stunPhrase = this.stunPercentLookup[stunPercent-1];
            assessment = stunPhrase;
            if (woundPercent>0&&woundPercent<10){
                woundPhrase = this.woundPercentLookup[woundPercent-1];
                assessment = stunPhrase+" and "+woundPhrase;
                if (mortalPercent>0){
                    mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                    assessment = stunPhrase+", "+woundPhrase+", and "+mortalPhrase;
                }
            } else if (mortalPercent>0&&mortalPercent<10){
                    mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                    assessment = stunPhrase+" and "+mortalPhrase;
            } else if (woundPercent>=10){
                if (!isUndead){
                woundPhrase = "unconscious";    
                } else {
                woundPhrase = "in a pain trance"
                }
                assessment = woundPhrase;
                if (mortalPercent>0){
                    mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                    assessment = woundPhrase+" and "+mortalPhrase;
                } else {
                    assessment = woundPhrase+" and "+this.woundPercentLookup[woundPercent-1];
                }
            }else if (mortalPercent>=10){
                    assessment = "dead"
            }
        } else if (woundPercent>0&&woundPercent<10){
//////            // console.log("woundPercent>0&&woundPercent<10");
            woundPhrase = this.woundPercentLookup[woundPercent-1];
            assessment = woundPhrase;
            if (mortalPercent>0&&mortalPercent<10){
//////                console.log("adding mortal..."+mortalPercent);
                mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
                assessment = mortalPhrase;
            }else if (mortalPercent>=10){
                    assessment = "dead"
            }
        } else if (mortalPercent>0&&mortalPercent<10){
//////            // console.log("mortalPercent>0&&mortalPercent<10");
            mortalPhrase = this.mortalPercentLookup[mortalPercent-1];
            assessment = mortalPhrase;
        } else {
//////            //console.log("no condition tripped, must be fine");
            if (this==playerCharacter.details){
                assessment = "shaken, but otherwise unhurt";
            } else {
                assessment = "completely unhurt"
            }
            
        }

        assessment = " was "+assessment+".";

        return assessment;
    }


	this.addInventoryItem = function(item) {

    }

    this.removeInventoryItem = function(item) {

    }

    this.doActionCheck = function(difficulty) { 
        //JRR need to add armor penalty to action check
        return skillCheck(0, this.actionCheck);
    }

    this.doSkillCheck = function(difficulty, skillTarget){
        var skillResult = skillCheck(difficulty, skillTarget);
        if (skillResult<=3){
            return skillResult;
        } else {
            return false;    
        }
    	
    }

    this.doExposureCheck = function (penalty){
        staminaSkill = this.skills['staminaEndurance'];

        //check for any exposure modifiers based on equipment

        //roll the skill check

        //apply stun damage as necessary
    }

    this.checkArmorBlock = function (damNum,damType,damKind,damSeverity){

        var armorRoll = null

        if (!this.armor){
        return damNum;
        } else {
        switch (damKind){
            case "li":
                armorRoll = this.armor.armor[0];
            break;  
            case "hi":
                armorRoll = this.armor.armor[1];
            break;
            case "en":
                armorRoll = this.armor.armor[2];
            break;
        }

        var armorRoll = rollDice(armorRoll[0],armorRoll[1],armorRoll[2]);

        if (armorRoll>0){
            var reducedDam = damNum-armorRoll;
            if (reducedDam<1){
//////               // console.log("Armor blocked all the damage!");
                return 0;
            } else {
//////             //   console.log("Armor blocked: " + armorRoll);
                return reducedDam;
            }
        } else {
//////           // console.log("Armor blocks: 0!");
            return damNum;
        }

        }
        


    }

    this.takeBlockableDamage = function (damNum,damType,damKind,damSeverity){
        var isUndead = false;
            
            if ('flags' in this){
                for (var i=0;i<this.flags.length;i++){
                    if (this.flags[i]=="undead"){
                        isUndead = true;
                    }
                }
            }
            
        
        //Reduce damage according to armor!
        remainingDamage = this.checkArmorBlock(damNum,damType,damKind,damSeverity);

        
        switch(damType){
            case "s":
            this.stun += remainingDamage;
            break;
            case "w":
            this.wound += remainingDamage;
            this.stun += Math.floor(remainingDamage/2);
            break;
            case "m":
            this.mortal += remainingDamage;
            this.wound += Math.floor(remainingDamage/2);
            this.stun += Math.floor(remainingDamage/2);
            if (remainingDamage>0){
            //this.combatView.innerHTML = this.combatView.innerHTML+"<br/><br/>"+ 'Blood spatters on the ground!';    
            //this.combatView.scrollTop = this.combatView.scrollHeight;
            }
            
            break;
        }

        if (this.stun>=this.constitution){

            

            //apply spillover wound damage

            this.wound += Math.floor((this.stun - this.constitution)/2);
            if (this.wound>=this.constitution){
                this.wound = this.constitution;
//////                //console.log("setting mortal from stun wound");
                this.mortal += Math.floor((this.wound -this.constitution)/4);
            }

            this.stun = this.constitution;

            
            if (isUndead){
                this.unconscious = false;
            } else {
                this.unconscious = true;
                if (this==playerCharacter['details']&&(remainingDamage>0||remainingDamage==-1)){
                            ////console.log("~~~~UPDATING HUD~~~~~~~");
                            // updateHUD();
                        }
                return -1;

            }
        }
////////console.log("CHECKING IF MAXED WOUND:");
        if (this.wound>=this.constitution){
//////        //    console.log(this.sdesc+" takes "+remainingDamage+damType+"!");
            
//////          //  console.log("setting mortal from wound! wound");
            this.mortal += Math.floor((this.wound -this.constitution)/2);
            this.wound = this.constitution;

            if (isUndead){
                this.unconscious = false;
            } else {
                this.unconscious = true;
                if (this==playerCharacter['details']&&(remainingDamage>0||remainingDamage==-1)){
                            ////console.log("~~~~UPDATING HUD~~~~~~~");
                            // updateHUD();
                        }
                return -1;

            }
        }

        if (this.mortal>=Math.floor(this.constitution/2)){
        
            var maxMortal = Math.floor(this.constitution/2);

//////            console.log(this.sdesc+" takes "+remainingDamage+damType+"!");
            this.unconscious = true;

            this.mortal = maxMortal;
            if (this==playerCharacter['details']&&(remainingDamage>0||remainingDamage==-1)){
                        ////console.log("~~~~UPDATING HUD~~~~~~~");
                        // updateHUD();
                    }

            return -1;

        }

        if (this==playerCharacter['details']&&(remainingDamage>0||remainingDamage==-1)){
            ////console.log("~~~~UPDATING HUD~~~~~~~");
            // updateHUD();
        }

        return remainingDamage;

    }

    this.recoverDamage = function (damNum,damType){
        switch(damType){
            case "s":
            this.stun -= damNum;
            if (this.stun<0){this.stun=0}
            break;
            case "w":
            this.wound -= damNum;
            if (this.wound<0){this.wound=0}
            break;
            case "m":
            this.mortal -= damNum;
            if (this.mortal<0){this.mortal=0}            
            break;
        }
        if (this==playerCharacter['details']){
             updateHUD();
        }
    }

    this.takeDirectDamage = function (damNum,damType){

        switch(damType){
            case "s":
            this.stun += damNum;
            break;
            case "w":
            this.wound += damNum;
            this.stun += Math.floor(damNum/2);
            break;
            case "m":
            this.mortal += damNum;
            this.wound += Math.floor(damNum/2);
            this.stun += Math.floor(damNum/2);
            if (damNum>0){
            }
            
            break;
        }

        var isUndead = false;
//////            //console.log("checking if undead!");
            if ('flags' in this){
                for (var i=0;i<this.flags.length;i++){
                    if (this.flags[i]=="undead"){
                        isUndead = true;
                    }
                }
            }
            
//////console.log("checking stun...");
        if (this.stun>=this.constitution){
//////            console.log(this.sdesc+" takes "+damNum+damType+"!");
            

            //apply spillover wound damage
            this.wound += Math.floor((this.stun - this.constitution)/2);
            if (this.wound>=this.constitution){
                this.wound = this.constitution;
                this.mortal += Math.floor((this.wound -this.constitution)/4);
            }

            this.stun = this.constitution;

             if (isUndead){
                this.unconscious = false;
                return damNum;
            } else {
                this.unconscious = true;
                return -1;
            }
        }
//////console.log("checking wound...");
        if (this.wound>=this.constitution){
//////            console.log(this.sdesc+" takes "+damNum+damType+"!");
            

            this.mortal += Math.floor((this.wound -this.constitution)/2);
            this.wound = this.constitution;
             if (isUndead){
                this.unconscious = false;
                return damNum;
            } else {
                this.unconscious = true;
                return -1;
            }
        }

//////        console.log("checking mortal...");

        if (this.mortal>=Math.floor(this.constitution/2)){
//////            console.log("mortal is maxed out!");
            var maxMortal = Math.floor(this.constitution/2);

//////            console.log(this.sdesc+" takes "+damNum+damType+"!");
            this.unconscious = true;

            this.mortal = maxMortal;

            return -1;
        }

        if (this==playerCharacter['details']){
                
            // updateHUD();
        }

        return damNum;

    }

    this.getUnarmedDamage = function(skillResult){
        var mod = this.getResMod("strength");
        switch (skillResult){
            case 3:
            return [rollDice(1, 3, 1)+mod,"s","li","o"];
            break;
            case 2:
            return [rollDice(1, 3, 2)+mod,"s","li","o"];
            break;
            case 1:
            return [rollDice(1, 3, 3)+mod,"s","li","o"];
            break
        }

    }

    this.attack = function (special){
//////        console.log("");
//////        console.log("-----------------------------------------------");
//////        console.log("Character attacking: " +this.sdesc+", target:"+this.target.sdesc);
        

        var possessivePerson =  "";
        if (this != playerCharacter.details){
            possessivePerson = "'s";
        } else {
            possessivePerson = "r";
        }

        var targetPossessivePerson="";
        if (this.target != playerCharacter.details){
            targetPossessivePerson = "'s";
        } else {
            targetPossessivePerson = "r";
        }
        // it's either nothing or 's
         // is it YOUR attack or OTHER's attack
        // SECOND or THIRD person; YOUR or SDESC+s 
        //if this is playercharacter.details
        //secondPersonPossessive is "your"
        //else //secondPersonPossessive is "this.sdesc"+'s
        // the armor block is unique in that it does happen to both the playerchar and npc
        //things like bait work now because they are always done by npcs


        var thirdPS = "s";
        var targetS = ""
        var thirdPES = "es";

        var aimBonus = 0;
        var dodgePenalty = 0;
        var dodgerPenalty = 0;
        var baitPenalty = 0;
        var isUndead = false;
        var weaponAccuracy = 0;
        var mortalPenalty = this.mortal;

       

//////        //console.log("checking if undead!");
        if ('flags' in this){
            for (var i=0;i<this.flags.length;i++){
                if (this.flags[i]=="undead"){
                    isUndead = true;
                }
            }
        }

        if ('aiming' in this){
            aimBonus = -3;
            delete this.aiming;
        }
        if ('dodging' in this){
            dodgerPenalty = 2;
            
            this.dodging = this.dodging-1;
//////            console.log("Rounds left dodging:"+this.dodging);
            if (this.dodging<0){
                delete this.dodging;
//////                console.log("Finished dodging:"+this.dodging);
            }
        }
        if ('target' in this&&this['target']!=null){
            if ('dodging' in this.target){
                dodgePenalty = 3;
            }
            if ('countering' in this.target){
                this.target.countering = this.target.countering-1
                if (this.target.countering<0){
                    delete this.target.countering;
//////                    console.log("Finished countering:"+this.dodging);
                }
                
            }
        }
        if ('baited' in this){
            baitPenalty = 2;
            delete this.baited;
        }
        var attackPrefix="";
        var attackWord="";
        if ((baitPenalty == 2)){attackPrefix="Struggling, "};
        if ('target' in this&&this['target']!=null){
            if ('dodging' in this.target){attackPrefix="Though you dodge, "};
            if ('aiming' in this.target){attackPrefix="While you aim, "};
        }
        if (aimBonus == -3){attackPrefix="With true aim, "};


        if (this == playerCharacter.details){thirdPS = "";thirdPES = "";targetS="s"};
        if (!this.unconscious){
            ////console.log("Character is conscious!");
//////            //console.log(this.sdesc)
            if (this.target && !this.target.unconscious){
                ////console.log("Character has a conscious target!");
                if (special&&special!=-1){
                    ////console.log("Special attack detected...");
                    var specialStat = characterGenerator.skillLookup[special.skill]['stat'];
                    var skillTarget;
                    if (special.skill in playerCharacter.details.skills) {
                        ////console.log("Rolling stat: " + specialStat);
                        skillTarget = playerCharacter.details[specialStat] + playerCharacter.details.skills[special.skill].rank;
                    } else {
                        ////console.log("Rolling stat: " + specialStat);
                        skillTarget = Math.floor(playerCharacter['details'][specialStat] / 2);
                        ////console.log("Rolling untrained! " + skillTarget);
                    }

                    var targetResMod = this.target.getResMod("strength");
                    //JRR add a check for undead before adding mortal pentalty
                    var result;
                    
                    
                    //if its bait, cheap shot, or kick, doCombat and pass in variable
                    //if it is dodge, counter, aim, set a flag on the character, upate UI, and nextTick
                    switch (special.name){

                        case "Counter":
                            this.countering = 1;
                            return{result:this.sdesc+" focus"+thirdPES+" on "+this.target.sdesc+"'s movements...",damage:null};
                        break;
                        case "Dodge":
                            this.dodging = 2;
                            return{result:this.sdesc+" get"+thirdPES+" ready to dodge "+this.target.sdesc+"!",damage:null};
                        break;
                        case "Aim":
                            this.aiming = true;
                            return{result:this.sdesc+" line"+thirdPES+" up a shot at "+this.target.sdesc+"!",damage:null};
                        break;
                        case "Bait":
//////                        console.log("Attack Variables:"+" weaponAccuracy:"+weaponAccuracy+" mortalPenalty:"+mortalPenalty+" aimBonus:"+aimBonus+" dodgePenalty:"+dodgePenalty+" dodgerPenalty:"+dodgerPenalty+" baitPenalty:"+baitPenalty+" ...");
                            result = this.doSkillCheck(targetResMod+this.mortal+aimBonus+dodgePenalty+dodgerPenalty+baitPenalty, skillTarget);
                            if (result!=false){
                                this.target.baited = true;
//////                                //console.log("Attacking "+ this.target.sdesc +" with fists!");
                                var damage = this.getUnarmedDamage(result);
                                var damResult = this.target.takeBlockableDamage(damage[0],damage[1],damage[2],damage[3]);
                                if (damResult!=-1&&damResult!=0){
                                    return{result:attackPrefix+this.sdesc+" bait"+thirdPS+" <span class='wounded'>"+this.target.sdesc+"</span> with a slap!",damage:damResult};
                                } else if (damResult!=0){
                                    return{result:attackPrefix+this.sdesc+" knock"+thirdPS+" out <span class='wounded'>"+this.target.sdesc+"</span> with a slap!",damage:damResult};
                                } else {
                                    return{result:attackPrefix+this.sdesc+possessivePerson+" attack is blocked by "+this.target.sdesc+targetPossessivePerson+" <span class='armor'>"+this.target.armor.name+"</span>.",damage:damResult};
                                    //JRR Fix the armor report
                                }
                            } else {
                                if (aimBonus == -3){attackPrefix="Despite your aim, "};
                                if ('dodging' in this.target){
                                    return{result:attackPrefix+this.target.sdesc+" dodge "+this.sdesc+"'s baiting slap!",damage:null};
                                } else {
                                    return{result:attackPrefix+this.sdesc+" fail"+thirdPES+" to bait "+this.target.sdesc+"!",damage:null};
                                }
                            }
                        break;
                        case "Jab":
//////                      console.log("Attack Variables:"+" weaponAccuracy:"+weaponAccuracy+" mortalPenalty:"+mortalPenalty+" aimBonus:"+aimBonus+" dodgePenalty:"+dodgePenalty+" dodgerPenalty:"+dodgerPenalty+" baitPenalty:"+baitPenalty+" ...");
                            result = this.doSkillCheck(targetResMod+this.mortal+aimBonus+dodgePenalty+dodgerPenalty+baitPenalty-3, skillTarget);
                            if (result!=false){
//////                                //console.log("Attacking "+ this.target.sdesc +" with fists!");
                                var damage = this.getUnarmedDamage(result);
                                var reducedDamage = damage - 1;
                                if (reducedDamage<0){reducedDamage=0}
                                var damResult = this.target.takeBlockableDamage(damage[0],damage[1],damage[2],damage[3]);
                                if (damResult!=-1&&damResult!=0){
                                    return{result:attackPrefix+this.sdesc+" jab"+thirdPS+" <span class='wounded'>"+this.target.sdesc+"</span>!",damage:damResult};
                                } else if (damResult!=0){
                                    return{result:attackPrefix+this.sdesc+" knock"+thirdPS+" out <span class='wounded'>"+this.target.sdesc+"</span> with a jab!",damage:damResult};
                                } else {
                                    return{result:attackPrefix+this.sdesc+possessivePerson+" attack is blocked by "+this.target.sdesc+targetPossessivePerson+" <span class='armor'>"+this.target.armor.name+"</span>.",damage:damResult};
                                    //JRR Fix the armor report
                                }
                            } else {
                                if (aimBonus == -3){attackPrefix="Despite your aim, "};
                                if ('dodging' in this.target){
                                    return{result:attackPrefix+this.target.sdesc+" dodge "+this.sdesc+"'s jab!",damage:null};
                                } else {
                                    return{result:attackPrefix+this.sdesc+" miss"+thirdPES+" a jab at "+this.target.sdesc+"!",damage:null};
                                }
                            }
                        break;
                        case "Kick":
//////                      console.log("Attack Variables:"+" weaponAccuracy:"+weaponAccuracy+" mortalPenalty:"+mortalPenalty+" aimBonus:"+aimBonus+" dodgePenalty:"+dodgePenalty+" dodgerPenalty:"+dodgerPenalty+" baitPenalty:"+baitPenalty+" ...");
                            result = this.doSkillCheck(targetResMod+this.mortal+aimBonus+dodgePenalty+dodgerPenalty+baitPenalty, skillTarget);
                            if (result!=false){
//////                                //console.log("Attacking "+ this.target.sdesc +" with fists!");
                                var damage = this.getUnarmedDamage(result);
                                var damResult = this.target.takeBlockableDamage(damage[0],damage[1],damage[2],damage[3]);
                                if (damResult!=-1&&damResult!=0){
                                    return{result:attackPrefix+this.sdesc+" kick"+thirdPS+" <span class='wounded'>"+this.target.sdesc+"</span>!",damage:damResult};
                                } else if (damResult!=0){
                                    return{result:attackPrefix+this.sdesc+" knock"+thirdPS+" out <span class='wounded'>"+this.target.sdesc+"</span> with a kick!",damage:damResult};
                                } else {
                                    return{result:this.sdesc+possessivePerson+" attack is blocked by "+this.target.sdesc+targetPossessivePerson+" <span class='armor'>"+this.target.armor.name+"</span>.",damage:damResult};
                                    //JRR Fix the armor report
                                }
                            } else {
                                if (aimBonus == -3){attackPrefix="Despite your aim, "};
                                if ('dodging' in this.target){
                                    return{result:attackPrefix+this.target.sdesc+" dodge "+this.sdesc+"'s kick!",damage:null};
                                } else {
                                    return{result:attackPrefix+this.sdesc+" miss"+thirdPES+" a kick at "+this.target.sdesc+"!",damage:null};
                                }
                                    
                            }
                        break;
                        default:
                        break;
                    }
            } else  {
//////                console.log("Regular attack detected...");
                //new DRY attack function
                var armedAttack = ((this.weapon) && !('forceMelee' in this.target));
                var brawlingChosen = ('Brawling' in this.skills);
                var requiredSkill;
                var skillTarget;
                
                var attackWords = ["slugs","slug"]; //create the default damage words and damage dice for unarmed attacks
                var damageDice = [[1,4,0,"s"],[1,4,1,"s"],[1,4,2,"s"]];
                var attackType = ["li","o"];
                var damageResMod = 0;

                //Need to get a number for skill target
                //Start by getting the relevent skill
                if (armedAttack){
                    attackType = this.weapon.type
                    damageDice = this.weapon.damage
                    attackWords = this.weapon.words;
                    weaponAccuracy = this.weapon.acc;
                    requiredSkill = this.weapon.skill;
                } else {
                    if ('forceMelee' in this.target){
                        attackWords = this.target.forceMeleeWords
                    }
                    requiredSkill = "Brawling";
                    damageResMod = this.getResMod("strength");
                }
//////                console.log("checking for required skill "+requiredSkill+"in");
//////                console.log(this.skills);
                //Find a skill target for the character based on the required skill and their chosen skills
                if (requiredSkill in this.skills){
//////                    console.log("requiredSkill is in skills");
                    //First check if the 
                    requiredSkill = this.skills[requiredSkill];
                    skillTarget = this[requiredSkill.stat]+requiredSkill.rank;
                } else {
//////                    console.log("requiredSkill is NOT in skills");
                    //what if the skill doesn't exist?
                    //get a skillTarget for an untrained skill
                    if (armedAttack){
//////                        console.log("armed attack!");
                        requiredSkill = characterGenerator.skillLookup[this.weapon.skill];
//////                        console.log(requiredSkill);
                        skillTarget = Math.floor(playerCharacter.details[requiredSkill.stat]/2);
//////                        console.log(skillTarget)
                    } else {
//////                        console.log("unarmed attack!!");
                        requiredSkill = characterGenerator.skillLookup["Brawling"];
                        skillTarget = Math.floor(playerCharacter.details['strength']/2); //unarmed untrained
                    }
                    
                }
                     
                var targetResMod = this.target.getResMod(requiredSkill.stat);
                if (isUndead){mortalPenalty = Math.floor(mortalPenalty/2);} //undead take half the penalties for mortal damage
            
                //****** Actual Attack Roll ********//
//////              console.log("Attack Variables: tagetResMod: "+targetResMod+" weaponAccuracy:"+weaponAccuracy+" mortalPenalty:"+mortalPenalty+" aimBonus:"+aimBonus+" dodgePenalty:"+dodgePenalty+" dodgerPenalty:"+dodgerPenalty+" baitPenalty:"+baitPenalty+" ...");
                var result = this.doSkillCheck(targetResMod+weaponAccuracy+mortalPenalty+aimBonus+dodgePenalty+dodgerPenalty+baitPenalty, skillTarget);
//////                console.log("Attack result: "+result);

                ////console.log("The attack has hit. Interject and check if countering. ");
                //If so, let the defending character make a counter-attack to block damage and inflict their own.
                var counterTarget;
                var counterResult = false;
                if ('countering' in this.target){
                    ////console.log("BUT THE TARGET IS COUNTERING!");
                    if ('Awareness' in this.target.skills){
                        counterTarget = this.target.willpower+this.target.skills['Awareness']['rank'];
                    } else {
                        counterTarget = Math.floor(this.target.willpower/2);
                    }

                    var targetAimBonus=0;
                    var targetAimPhrase="";
                    if ('aiming' in this.target){
                        targetAimBonus=-3;
                        targetAimPhrase="With true aim, ";
                        delete this.target.aiming;
                    }
                    ////console.log("CHECKING COUNTER RESULT");
                    counterResult = this.target.doSkillCheck(0+targetAimBonus, counterTarget);

                    if ((counterResult)){
//////                        console.log("COUNTER RESULT IS BETTER!");
//////                        console.log(counterResult);
                        //reset damage dice
                        damageDice = [[1,4,0,"s"],[1,4,1,"s"],[1,4,2,"s"]];
                        damageDice = damageDice[2-(counterResult-1)];
//////                        console.log("DAMAGE DICE:");
//////                        console.log(damageDice);
                        var damage = rollDice(damageDice[0],damageDice[1],damageDice[2]);
                        var damResult = this.takeBlockableDamage(damage,damageDice[3],attackType[0],attackType[1]);
                        ////console.log("Damage dealt, function returned: "+damResult);
                        
                        if (damResult!=-1&&damResult!=0){
                            ////console.log("COUNTER LANDS");
                            return{result:targetAimPhrase+"you counter <span class='wounded'>"+this.sdesc+"</span>'s "+attackWords[1]+"!",damage:damResult};
                        } else if (damResult!=0){
                            ////console.log("COUNTER and CRUMPLE! -3");
                            var deathPhrase = ("You counter <span class='wounded'>"+this.sdesc+"'s</span> "+attackWords[1]+" and "+this.pronoun+" crumple"+thirdPS+"!");
                            //this.combatView.innerHTML = this.combatView.innerHTML+"<br/><br/>"+ this.sdesc+" "+attackWords[0]+" "+this.target.sdesc+" and "+this.target.pronoun+" crumples!";    
                            //this.combatView.scrollTop = this.combatView.scrollHeight;
                            return {result:-3,damage:damResult,deathPhrase:deathPhrase};

                        } else {
                            ////console.log("COUNTER is BLOCKED");
                            return{result:"Your counter is blocked by "+this.sdesc+"'s <span class='armor'>"+this.armor.name+"</span>.",damage:damResult};
                        }
                    }else {
//////                        console.log("COUNTER RESULT IS A FAIL!");
                        delete this.target.countering;
                    }
                }
                
                if (result!=false){
//////                    console.log("Do damage!");
                    damageDice = damageDice[2-(result-1)];
                    var damage = rollDice(damageDice[0],damageDice[1],damageDice[2])+damageResMod; //add the strength resistance modifier to damage
//////                    console.log("Damage rolled with resistance modifier of "+damageResMod+":"+damage);
                    var damResult = this.target.takeBlockableDamage(damage,damageDice[3],attackType[0],attackType[1]);

//////                    console.log("Damage dealt, function returned: "+damResult);
                    
                   
                    if (this==playerCharacter.details){attackWord = attackWords[1]}else{attackWord = attackWords[0]};
                    if (damResult!=-1&&damResult!=0){
                        if (armedAttack){
                            if ('vampiric' in this.weapon){
                                this.recoverDamage(3, "s");
                                this.recoverDamage(2, "w");
                                this.recoverDamage(1, "m");
                            }
                        }
                        return{result:attackPrefix+this.sdesc+" "+attackWord+" <span class='wounded'>"+this.target.sdesc+"</span>!"/*+" ("+damResult+damageDice[3]+")"*/,damage:damResult};
                    } else if (damResult!=0){
                        var deathPhrase = (attackPrefix+this.sdesc+" "+attackWord+" <span class='wounded'>"+this.target.sdesc+"</span> and "+this.target.pronoun+" crumple"+targetS+"!");
                        //this.combatView.innerHTML = this.combatView.innerHTML+"<br/><br/>"+ this.sdesc+" "+attackWord+" "+this.target.sdesc+" and "+this.target.pronoun+" crumples!";    
                        //this.combatView.scrollTop = this.combatView.scrollHeight;
                        ////console.log("SOMEBODY JUST DIED");
                        return {result:-2,damage:damResult,deathPhrase:deathPhrase};

                    } else {
                        return{result:this.sdesc+possessivePerson+" attack is blocked by "+this.target.sdesc+targetPossessivePerson+" <span class='armor'>"+this.target.armor.name+"</span>.",damage:damResult};
                        //JRR Fix the armor report
                    }
                    
                } else {
//////                    // console.log("CHECKING IF TARGET IS DODGING");
//////                    // console.log(this);
                    if (aimBonus == -3){attackPrefix="Despite your aim, "};
                    if ('dodging' in this.target){
                        return{result:this.target.sdesc+" dodge "+this.sdesc+"'s "+attackWords[1]+".",damage:null};
                    } else if (baitPenalty == 2){
//////                        console.log("BAIT PENALTY DETECTED");
                        return{result:this.sdesc+" struggles to regain ground.",damage:null};
                    } else {
                        return{result:attackPrefix+this.sdesc+" miss"+thirdPES+" a "+attackWords[1]+" at "+this.target.sdesc+"!",damage:null};
                    } 
                }                
            }
        } else if (this.target.unconscious){
            ////console.log("IT IS "+this.sdesc+"'s ATTACK ROLL");
            ////console.log("THE PERSON BEING ATTACKED IS UNCONSCIOUS! "+this.target.sdesc);
            ////console.log("GET NEW TARGET!");
            ////console.log("Returning -2 so you know to find a new target");
            return {result:-2,damage:null};
        } else {
//////            console.log("I AM NOT UNCONSCIOUS!");
//////            console.log("something wrong with target!");
//////            console.log("i am "+this.sdesc);
//////            console.log(this.target)
//////            console.log(this.target.unconscious);
            
            return {result:-1,damage:null};
        }
    } else {
//////        //console.log("I AM UNCONSCIOUS! ZZZ");
        return {result:-1,damage:null};
    }
    }

}