function characterGenerator () {
    this.skillLookup = {
        "Fitness":{stat:"strength", image:"images/fitnessico.png",name:"Fitness"},
        "Brawling":{stat:"strength", image:"images/brawlingico.png",name:"Brawling"},
        "meleeBlade":{stat:"strength", image:"images/brawlingico.png",name:""},
        "meleeBludgeon":{stat:"strength", image:"images/brwalingico.png",name:""},
        "Marksmanship":{stat:"dexterity", image:"images/marksmanshipico.png",name:"Gunplay"},
        "Ancient Languages":{stat:"intelligence", image:"images/ancientlanguagesico.png",name:"Symbols"},
        "staminaEndurance":{stat:"constitution", image:"images/fitnessico.png",name:"Stamina"},
        "Awareness":{stat:"willpower", image:"images/awarenessico.png",name:"Awareness"},
        "Cunning":{stat:"intelligence", image:"images/cunningico.png",name:"Cunning"}
    }

this.generateSDesc = function(type){
	var firstHalf = [];
	var secondHalf = [];

	switch (type){
        case "spider":
            firstHalf = ["furry","white-marked","blue-ringed","thin-legged","dark-bodied","quivering","hairy"];
            firstHalf = firstHalf[Math.floor(Math.random() * firstHalf.length)];
            return "the "+firstHalf+" spider";
		case "dog":
            firstHalf = ["scruffy","scraggly","mangy","filthy","foaming","rabid","festering"];
            secondHalf = ["claw-scarred","yellow-toothed","sore-covered","malnourished","knobby-boned","bloody-gummed","foul-smelling"];
            firstHalf = firstHalf[Math.floor(Math.random() * firstHalf.length)];
            secondHalf = secondHalf[Math.floor(Math.random() * secondHalf.length)];
            return "the "+firstHalf+", "+secondHalf+" dog";
        case "feral acolyte":
            firstHalf = ["pale","pallid","sickly","sallow","feral","festering"];
            secondHalf = ["claw-scarred","sharp-toothed","malnourished","knobby-boned","foul-smelling"];
            firstHalf = firstHalf[Math.floor(Math.random() * firstHalf.length)];
            secondHalf = secondHalf[Math.floor(Math.random() * secondHalf.length)];
            return "the "+firstHalf+", "+secondHalf+" humanoid";
        default:
			firstHalf = ["frantic","violent","desperate","filthy","grimy","reeking","wasteland"];
			secondHalf = ["scumbag","scavenger","cannibal","murderer","robber","degenerate"];
            firstHalf = firstHalf[Math.floor(Math.random() * firstHalf.length)];
            secondHalf = secondHalf[Math.floor(Math.random() * secondHalf.length)];
            return "the "+firstHalf+" "+secondHalf+"";
		break;
	}
}

this.generateImg = function(type){
var imageArray;
var image;

    switch (type){
        case "dog":
            imageArray = ["character33thumb.png"];
            image = imageArray[Math.floor(Math.random() * imageArray.length)];
            return image;
        case "spider":
            imageArray = ["character5thumb.png"];
            image = imageArray[Math.floor(Math.random() * imageArray.length)];
        return image;

        case "sid":
            imageArray = ["character8thumb.png"];
            image = imageArray[Math.floor(Math.random() * imageArray.length)];
        return image;

        case "geologist":
            imageArray = ["character4thumb.png"];
            image = imageArray[Math.floor(Math.random() * imageArray.length)];
        return image;

        case "feral acolyte":
            imageArray = ["character3thumb.png"];
            image = imageArray[Math.floor(Math.random() * imageArray.length)];
        return image;

        default:
            imageArray = ["character21thumb.png","character20thumb.png","character19thumb.png","character17thumb.png","character7thumb.png","character4thumb.png"];
            image = imageArray[Math.floor(Math.random() * imageArray.length)];
            return image;
        break;
    }
}

this.createCharFromProperties = function (character){
    console.log(character);
    var newChar = new character();
    newChar.initWithCharacter(character);
    return newChar;
}

this.createCharWithTemplate = function(persona){
    console.log("CREATING CHAR FROM TEMPLATE");
    	var newChar = new character();
    	switch(persona){
    		case "marginalBrawler":
                newChar.xp = 0;
    			newChar.xpValue = 1;
                newChar.strength = 10;
    			newChar.dexterity = 9;
    			newChar.constitution = 10;
    			newChar.intelligence = 8;
    			newChar.willpower = 9;
    			newChar.charisma = 8;
    			newChar.actionCheck = 8;
    			newChar.actionsNum = 2;
    			newChar.sdesc = this.generateSDesc();
                newChar.image = this.generateImg();
                newChar.pronoun = "he";
    			newChar.skills = {
    				"athletics":{rank:1,stat:"strength"},
    				"unarmedBrawl":{rank:1,stat:"strength"},
    				"meleeBlade":{rank:1,stat:"strength"},
                    "meleeBludgeon":{rank:1,stat:"strength"},
    				"modernRangedWeapons":{rank:1,stat:"dexterity"},
    				"vehicleOperation":{rank:1,stat:"dexterity"},
    				"staminaEndurance":{rank:1,stat:"constitution"},
    				"streetSmart":{rank:1,stat:"willpower"},
    				"interaction":{rank:1,stat:"charisma"}
    			};
                newChar.armor = itemGenerator.createItemWithTemplate("leatherCoat");
                newChar.weapon = itemGenerator.createItemWithTemplate("tireIron");
            break;
            case "amazingBrawler":
                newChar.xp = 0;
                newChar.xpValue = 2;
                newChar.strength = 14;
                newChar.dexterity = 12;
                newChar.constitution = 13;
                newChar.intelligence = 11;
                newChar.willpower = 11;
                newChar.charisma = 11;
                newChar.actionCheck = 14;
                newChar.actionsNum = 3;
                newChar.sdesc = this.generateSDesc();
                newChar.image = this.generateImg();
                newChar.pronoun = "he";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "unarmedBrawl":{rank:4,stat:"strength"},
                    "meleeBlade":{rank:3,stat:"strength"},
                    "meleeBludgeon":{rank:2,stat:"strength"},
                    "modernRangedWeapons":{rank:1,stat:"dexterity"},
                    "vehicleOperation":{rank:1,stat:"dexterity"},
                    "staminaEndurance":{rank:1,stat:"constitution"},
                    "streetSmart":{rank:1,stat:"willpower"},
                    "interaction":{rank:1,stat:"charisma"}
                };
                newChar.armor = itemGenerator.createItemWithTemplate("assaultGear");
                newChar.weapon = itemGenerator.createItemWithTemplate("axe");
            break;
            case "playerCharacter":
                newChar.xp = 0;
                newChar.xpValue = 0;
                newChar.strength = 11;
                newChar.dexterity = 13;
                newChar.constitution = 14;
                newChar.intelligence = 13;
                newChar.willpower = 13;
                newChar.charisma = 13;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = "you";
                newChar.image = this.generateImg("geologist");
                newChar.pronoun = "you";
                newChar.skills = {
                    //"fitness":{rank:1,stat:"strength"},
                    // "unarmedBrawl":{rank:4,stat:"strength"},
                    // "meleeBlade":{rank:3,stat:"strength"},
                    // "meleeBludgeon":{rank:4,stat:"strength"},
                    // "modernRangedWeapons":{rank:4,stat:"dexterity"},
                    // "vehicleOperation":{rank:1,stat:"dexterity"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                    //"streetSmart":{rank:1,stat:"willpower"},
                    //"interaction":{rank:1,stat:"charisma"}
                };
                newChar.soundGrowl= "Growl-01";
                newChar.soundPain= "Ouch-01";

                newChar.flags = [];

                newChar.imageAttack = "combat_tiles/slice01_01.png";
                newChar.imageTaunt = "combat_tiles/slice25_25.png";
                newChar.imageHurt = "combat_tiles/slice26_26.png";
                newChar.imageDead = "combat_tiles/slice27_27.png";

                
                //newChar.armor = itemGenerator.createItemWithTemplate("ballisticVest");
                //newChar.weapon = itemGenerator.createItemWithTemplate("baseballBat");
            break;
            case "zukath":
                newChar.xp = 0;
                newChar.xpValue = 0;
                newChar.strength = 9;
                newChar.dexterity = 9;
                newChar.constitution = 12;
                newChar.intelligence = 14;
                newChar.willpower = 14;
                newChar.charisma = 9;
                newChar.actionCheck = 12;
                newChar.actionsNum = 2;
                newChar.sdesc = "the bearded old man";
                newChar.image = ["character1thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    // "fitness":{rank:1,stat:"strength"},
                    // "unarmedBrawl":{rank:4,stat:"strength"},
                    // "meleeBlade":{rank:3,stat:"strength"},
                    // "meleeBludgeon":{rank:4,stat:"strength"},
                    // "modernRangedWeapons":{rank:4,stat:"dexterity"},
                    // "vehicleOperation":{rank:1,stat:"dexterity"},
                    "staminaEndurance":{rank:1,stat:"constitution"},
                    "Awareness":{rank:6,stat:"willpower"}
                    //"streetSmart":{rank:1,stat:"willpower"},
                    //"interaction":{rank:1,stat:"charisma"}
                };
                newChar.soundGrowl= "Lightning-03";
                newChar.soundPain= "Ouch-01";

                newChar.imageAttack = "combat_tiles/slice03_03.png";
                newChar.imageTaunt = "combat_tiles/slice09_09.png";
                newChar.imageHurt = "combat_tiles/slice15_15.png";
                newChar.imageDead = "combat_tiles/slice21_21.png";


                //newChar.armor = itemGenerator.createItemWithTemplate("ballisticVest");
                newChar.weapon = itemGenerator.createItemWithTemplate("lightningSigil");
            break;
            case "zukath2":
                newChar.xp = 0;
                newChar.xpValue = 0;
                newChar.strength = 9;
                newChar.dexterity = 9;
                newChar.constitution = 12;
                newChar.intelligence = 10;
                newChar.willpower = 10;
                newChar.charisma = 9;
                newChar.actionCheck = 12;
                newChar.actionsNum = 2;
                newChar.sdesc = "the bearded old man";
                newChar.image = ["character1thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    // "fitness":{rank:1,stat:"strength"},
                    // "unarmedBrawl":{rank:4,stat:"strength"},
                    // "meleeBlade":{rank:3,stat:"strength"},
                    // "meleeBludgeon":{rank:4,stat:"strength"},
                    // "modernRangedWeapons":{rank:4,stat:"dexterity"},
                    // "vehicleOperation":{rank:1,stat:"dexterity"},
                    "staminaEndurance":{rank:1,stat:"constitution"},
                    "Awareness":{rank:6,stat:"willpower"}
                    //"streetSmart":{rank:1,stat:"willpower"},
                    //"interaction":{rank:1,stat:"charisma"}
                };
                newChar.soundGrowl= "Lightning-03";
                newChar.soundPain= "Ouch-01";

                newChar.imageAttack = "combat_tiles/slice03_03.png";
                newChar.imageTaunt = "combat_tiles/slice09_09.png";
                newChar.imageHurt = "combat_tiles/slice15_15.png";
                newChar.imageDead = "combat_tiles/slice21_21.png";


                //newChar.armor = itemGenerator.createItemWithTemplate("ballisticVest");
                newChar.weapon = itemGenerator.createItemWithTemplate("lightningSigilEnraged");
            break;
            case "antonio":
                newChar.xp = 0;
                newChar.xpValue = 0;
                newChar.strength = 14;
                newChar.dexterity = 10;
                newChar.constitution = 15;
                newChar.intelligence = 10;
                newChar.willpower = 10;
                newChar.charisma = 5;
                newChar.actionCheck = 12;
                newChar.actionsNum = 2;
                newChar.sdesc = "the tentacled humanoid";
                newChar.image = ["character1thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    // "fitness":{rank:1,stat:"strength"},
                    // "unarmedBrawl":{rank:4,stat:"strength"},
                    // "meleeBlade":{rank:3,stat:"strength"},
                    // "meleeBludgeon":{rank:4,stat:"strength"},
                    // "modernRangedWeapons":{rank:4,stat:"dexterity"},
                    // "vehicleOperation":{rank:1,stat:"dexterity"},
                    "meleeNatural":{rank:3,stat:"strength"},
                    "staminaEndurance":{rank:1,stat:"constitution"},
                    "Awareness":{rank:6,stat:"willpower"}
                    //"streetSmart":{rank:1,stat:"willpower"},
                    //"interaction":{rank:1,stat:"charisma"}
                };
                newChar.soundGrowl= "Antonio-Grunt-01";
                newChar.soundPain= "Ouch-01";
                newChar.imageAttack = "combat_tiles/slice29_29.png";
                newChar.imageTaunt = "combat_tiles/slice33_33.png";
                newChar.imageHurt = "combat_tiles/slice36_36.png";
                newChar.imageDead = "combat_tiles/slice39_39.png";

                //newChar.armor = itemGenerator.createItemWithTemplate("ballisticVest");
                newChar.weapon = itemGenerator.createItemWithTemplate("tentacles");
            break;
            case "marginalDog":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 12;
                newChar.dexterity = 12;
                newChar.constitution = 9;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = this.generateSDesc("dog");
                newChar.image = this.generateImg("dog");
                newChar.pronoun = "it";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:1,stat:"strength"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                newChar.armor = itemGenerator.createItemWithTemplate("dogHide");
                newChar.weapon = itemGenerator.createItemWithTemplate("dogTeeth");
            break;
            case "zealot1":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 9;
                newChar.dexterity = 12;
                newChar.constitution = 9;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = "the leering zealot";
                newChar.image = ["character6thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:2,stat:"strength"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                newChar.weapon = itemGenerator.createItemWithTemplate("zealot smother");
                newChar.soundGrowl= "Zealot-Growl-01";
                newChar.soundPain= "Feral-01";
                newChar.imageAttack = "combat_tiles/slice05_05.png";
                newChar.imageTaunt = "combat_tiles/slice11_11.png";
                newChar.imageHurt = "combat_tiles/slice17_17.png";
                newChar.imageDead = "combat_tiles/slice23_23.png";
            break;
            case "zealot2":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 12;
                newChar.dexterity = 12;
                newChar.constitution = 9;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = "the stringy-haired zealot";
                newChar.image = ["character7thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:2,stat:"strength"},
                    "Marksmanship":{rank:1,stat:"constitution"}
                };
                newChar.weapon = itemGenerator.createItemWithTemplate("zealot choke");
                newChar.soundGrowl= "Zealot-Growl-02";
                newChar.soundPain= "Feral-01";
                newChar.imageAttack = "combat_tiles/slice47_47.png";
                newChar.imageTaunt = "combat_tiles/slice42_42.png";
                newChar.imageHurt = "combat_tiles/slice48_48.png";
                newChar.imageDead = "combat_tiles/slice43_43.png";
            break;
            case "zealot3":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 9;
                newChar.dexterity = 12;
                newChar.constitution = 9;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = "the black-eyed zealot";
                newChar.image = ["character8thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:2,stat:"strength"},
                    "Marksmanship":{rank:4,stat:"dexterity"}
                };
                newChar.weapon = itemGenerator.createItemWithTemplate("blowgun");
                newChar.soundGrowl= "Zealot-Growl-03";
                newChar.soundPain= "Feral-01";
                newChar.imageAttack = "combat_tiles/slice06_06.png";
                newChar.imageTaunt = "combat_tiles/slice12_12.png";
                newChar.imageHurt = "combat_tiles/slice18_18.png";
                newChar.imageDead = "combat_tiles/slice24_24.png";
            break;
            case "feral acolyte":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 12;
                newChar.dexterity = 12;
                newChar.constitution = 9;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = "the feral acolyte";
                newChar.image = this.generateImg("feral acolyte");
                newChar.pronoun = "he";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:4,stat:"strength"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                newChar.armor = itemGenerator.createItemWithTemplate("dogHide");
                newChar.weapon = itemGenerator.createItemWithTemplate("dogTeeth");
                newChar.soundGrowl= "Feral-02";
                newChar.soundPain= "Feral-01";
                newChar.imageAttack = "combat_tiles/slice02_02.png";
                newChar.imageTaunt = "combat_tiles/slice08_08.png";
                newChar.imageHurt = "combat_tiles/slice14_14.png";
                newChar.imageDead = "combat_tiles/slice20_20.png";
            break;
            case "spider":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 8;
                newChar.dexterity = 13;
                newChar.constitution = 6;
                newChar.intelligence = 3;
                newChar.willpower = 3;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = this.generateSDesc("spider");
                newChar.image = this.generateImg("spider");
                newChar.pronoun = "it";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:2,stat:"strength"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                newChar.imageAttack = "combat_tiles/slice04_04.png";
                newChar.soundGrowl= "Spider-01";
                newChar.soundPain= "Spider-03";
                newChar.soundDeath= "Spider-03";
                newChar.imageTaunt = "combat_tiles/slice10_10.png";
                newChar.imageHurt = "combat_tiles/slice16_16.png";
                newChar.imageDead = "combat_tiles/slice22_22.png";
                newChar.weapon = itemGenerator.createItemWithTemplate("spiderTeeth");
                newChar.forceMelee=true;
                newChar.forceMeleeWords=["swats","swat","crushes"];
            break;
            case "jackal lord":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 15;
                newChar.dexterity = 8;
                newChar.constitution = 22;
                newChar.intelligence = 3;
                newChar.willpower = 8;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 1;
                newChar.sdesc = "the terrible JACKAL LORD";
                newChar.image = ["character9thumb.png"];
                newChar.pronoun = "he";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:4,stat:"strength"},
                    "Brawling":{rank:2,stat:"strength"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                newChar.armor = itemGenerator.createItemWithTemplate("dogHide");
                newChar.weapon = itemGenerator.createItemWithTemplate("a massive metal blade");
                newChar.soundGrowl= "Jackal-Growl-01";
                newChar.soundPain= "Jackal-Pain-01";
                newChar.imageAttack = "combat_tiles/slice30_30.png";
                newChar.imageTaunt = "combat_tiles/slice34_34.png";
                newChar.imageHurt = "combat_tiles/slice37_37.png";
                newChar.imageDead = "combat_tiles/slice40_40.png";
            break;
            case "centibeast":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 8;
                newChar.dexterity = 14;
                newChar.constitution = 12;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.sdesc = "the centi-beast";
                newChar.image = ["character9thumb.png"];
                newChar.pronoun = "it";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:4,stat:"strength"},
                    "Awareness":{rank:4,stat:"willpower"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                //newChar.armor = itemGenerator.createItemWithTemplate("forceShield");
                newChar.weapon = itemGenerator.createItemWithTemplate("centibeast glands");
                newChar.soundGrowl= "Centibeast-Crawl-01";
                newChar.soundPain= "Spider-03";
                newChar.imageAttack = "combat_tiles/slice31_31.png";
                newChar.imageTaunt = "combat_tiles/slice35_35.png";
                newChar.imageHurt = "combat_tiles/slice38_38.png";
                newChar.imageDead = "combat_tiles/slice41_41.png";
            break;
            case "centibeastWounded":
                newChar.xp = 0;
                newChar.xpValue = 1;
                newChar.strength = 8;
                newChar.dexterity = 14;
                newChar.constitution = 12;
                newChar.intelligence = 3;
                newChar.willpower = 12;
                newChar.charisma = 3;
                newChar.actionCheck = 14;
                newChar.actionsNum = 2;
                newChar.stun=8;
                newChar.sdesc = "the centi-beast";
                newChar.image = ["character9thumb.png"];
                newChar.pronoun = "it";
                newChar.skills = {
                    "athletics":{rank:1,stat:"strength"},
                    "meleeNatural":{rank:4,stat:"strength"},
                    "Awareness":{rank:4,stat:"willpower"},
                    "staminaEndurance":{rank:1,stat:"constitution"}
                };
                //newChar.armor = itemGenerator.createItemWithTemplate("forceShield");
                newChar.weapon = itemGenerator.createItemWithTemplate("centibeast glands");
                newChar.soundGrowl= "Centibeast-Crawl-01";
                newChar.soundPain= "Spider-03";
                newChar.imageAttack = "combat_tiles/slice31_31.png";
                newChar.imageTaunt = "combat_tiles/slice35_35.png";
                newChar.imageHurt = "combat_tiles/slice38_38.png";
                newChar.imageDead = "combat_tiles/slice41_41.png";
            break;
    		default:
    		break;
    	}

    	return newChar;
    }

}