function combatController() {

    var combatSummary = [];

    var combatHints = [
    "Every turn you will be able to attack with your wielded weapon, or one of six random specials.",
    "Attacks and specials are tied to skills. Having the required skill will improve your success.",
    "Consume a chocolate bar or vial from your stash, even during combat, if you are wounded.",
    "Not sure what an item is for? Open your stash and tap on it for hints.",
    "Specials with a duration will stack: you can simultaneously aim, counter, and dodge.",
    "Counter and dodge are useful defensive opportunities.",
    "Baiting is the only special that can disrupt enemy attacks.",
    "Aiming will provide a bonus to specials as well as regular attacks with your wielded weapon.",
    "A well-placed kick is stronger than an unarmed punch.",
    "Sustaining mortal damage makes it much more difficult to attack successfully."
    ];

    var pageLookup = {
        "70": {
            win: 77,
            lose: 79
        },
        "56": {
            win: 63,
            lose: 58
        },
        "104": {
            win: 102,
            lose: 94
        },
        "254": {
            win: 256,
            lose: 255
        },
        "250": {
            win: 251,
            lose: 94
        },
        "271": {
            win: 63,
            lose: 58
        },
        "277": {
            win: 63,
            lose: 58
        },
        "297": {
            win: 298,
            lose: 316
        },
        "310": {
            win: 298,
            lose: 316
        },
        "315": {
            win: 298,
            lose: 316
        },
        "303": {
            win: 328,
            lose: 339
        },
        "399": {
            win: 328,
            lose: 339
        },
        "359": {
            win: 361,
            lose: 362
        },
        "360": {
            win: 361,
            lose: 362
        },
        // "363": {
        //     win: 361,
        //     lose: 362
        // },
        "364": {
            win: 361,
            lose: 362
        },
        "365": {
            win: 361,
            lose: 362
        },
        "367": {
            win: 361,
            lose: 362
        },
        "368": {
            win: 361,
            lose: 362
        },
        "370": {
            win: 361,
            lose: 362
        },
        "405": {
            win: 256,
            lose: 255
        }
    }

    var aggroRoomLookup = {
        "70": true,
        "56": true,
        "104": true,
        "254": true,
        "250": true,
        "271": true,
        "277": true,
        "297":true,
        "303":true,
        "310":true,
        "315":true,
        "359":true,
        "360":true,
        // "363":true,
        "368":true,
        "370":true,
        "399":true,
        "364":true,
        "365":true,
        "367":true,
        "405":true
    }

    var combatChoiceLookup = [
        {
            name:"Bait",
            skill:"Cunning",
            difficulty:0,
            opportunityPhrase:"<li>weak attack</li><li>disrupts enemy attack</li>",
            image:"images/cunningico_100.png"
        },
        {
            name:"Counter",
            skill:"Awareness",
            difficulty:+1,
            opportunityPhrase:"<li>pass this turn</li><li>block next enemy attack</li><li>throw counter-punch</li>",
            image:"images/awarenessico_100.png"
        },
        {
            name:"Dodge",
            skill:"Fitness",
            difficulty:0,
            opportunityPhrase:"<li>pass this turn</li><li>gives defense bonus</li>",
            image:"images/fitnessico_100.png"
        },
        {
            name:"Aim",
            skill:"Awareness",
            difficulty:0,
            opportunityPhrase:"<li>pass this turn</li><li>strong next attack</li><li>works with specials</li>",
            image:"images/awarenessico_100.png"
        },
        {
            name:"Jab",
            skill:"Cunning",
            difficulty:-3,
            opportunityPhrase:"<li>strong chance to hit</li><li>low damage</li>",
            image:"images/cunningico_100.png"
        },
        {
            name:"Kick",
            skill:"Fitness",
            difficulty:0,
            opportunityPhrase:"<li>strong unarmed attack</li>",
            image:"images/fitnessico_100.png"
        }
    ]

    this.challengeLookup = {
        "15": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I snagged some roots as I plummeted and slowed my fall.", "I snagged some roots as I plummited and slowed my fall.", "I rolled myself onto my shoulder and broke some of the fall.", "I crashed like a rock into a pile of bones below."],
            passSound: "Fall-01",
            failSound: "Fall-01",
            deathPhrase: "I tumbled in the air and landed upside down -- the weight of my body crushed my neck!",
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 3, 0, "s"],
                [1, 4, 0, "s"],
                [1, 4, 1, "w"]
            ],
            deathPage: 276,
        },
        "170": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I held my breath with ease.",
                "I held my breath with ease.",
                "I struggled to hold my breath, but I pushed myself to keep going.",
                "I suffered without breath and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "s"],
                [1, 3, 1, "s"]
            ]
        },
        "171": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I held my breath with ease.",
                "I held my breath with ease.",
                "I struggled to hold my breath, but I pushed myself to keep going.",
                "I suffered without breath and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "s"],
                [1, 3, 1, "s"]
            ]
        },
        "172": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I held my breath with ease.",
                "I held my breath with ease.",
                "I struggled to hold my breath, but I pushed myself to keep going.",
                "I suffered without breath and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "s"],
                [1, 3, 1, "s"]
            ]
        },
        "179": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I held my breath with ease.",
                "I held my breath with ease.",
                "I struggled to hold my breath, but I pushed myself to keep going.",
                "I suffered without breath and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "s"],
                [1, 3, 1, "s"]
            ]
        },
        "180": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I held my breath with ease.",
                "I held my breath with ease.",
                "I struggled to hold my breath, but I pushed myself to keep going.",
                "I suffered without breath and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "s"],
                [1, 3, 1, "s"]
            ]
        },
        "177": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I held my breath with ease.",
                "I held my breath with ease.",
                "I struggled to hold my breath, but I pushed myself to keep going.",
                "I suffered without breath and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "s"],
                [1, 3, 1, "s"]
            ]
        },
        "268": {
            skill: "Fitness",
            difficulty: 2,
            resultPhrases: ["I held my breath as I fought the current!",
                "I held my breath as I fought the current!",
                "I wasted air fighting against the current and felt myself weaken!",
                "I wasted my air fighting and started to panic!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "I couldn't stand it any longer -- I gasped for air!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 4, 1, "s"],
                [1, 6, 1, "s"]
            ]
        },
        "269": {
            skill: "Fitness",
            difficulty: 2,
            resultPhrases: ["I held my breath and tumbled gracefully through the sharp rocks!",
                "I held my breath and tumbled gracefully through the sharp rocks!",
                "I tumbled clumsily and the sharp rocks clawed my body!",
                "The current ruthlessly tore me over the sharp rocks!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "Tumbling helplessly in the current, I knocked my head against a rock!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 0, "w"],
                [1, 3, 1, "w"]
            ]
        },
        "270": {
            skill: "Fitness",
            difficulty: 2,
            resultPhrases: ["I held my breath and tumbled gracefully through the sharp rocks!",
                "I held my breath and tumbled gracefully through the sharp rocks!",
                "I tumbled and tumbled, knocked against the rocks!",
                "The current viciously raked me against the rough tunnel!"
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "Tumbling helplessly in the current, I knocked my head against a rock!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 0, "w"],
                [1, 3, 1, "w"]
            ]
        },
        "182": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["I burst through the surface and gasped for air."],
            passSound: "Gasp-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 5);
                playerCharacter.details.recoverDamage(healNumber, "s");
            }
        },
        "181": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["I burst through the surface and gasped for air."],
            passSound: "Gasp-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 5);
                playerCharacter.details.recoverDamage(healNumber, "s");
            }
        },
        "188": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["I burst through the surface and gasped for air."],
            passSound: "Gasp-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 2);
                playerCharacter.details.recoverDamage(healNumber, "s");
            }
        },
        "97": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["After taking a minute, my head felt clearer."],
            passSound: "Panting-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 2);
                playerCharacter.details.recoverDamage(healNumber, "s");
            }
        },
        "106": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["Though my thoughts raced, my body rested."],
            passSound: "Panting-02",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                //heal
                var healNumber = rollDice(1, 6, 5);
                playerCharacter.details.recoverDamage(healNumber, "s");
                healNumber = rollDice(1, 3, 0);
                playerCharacter.details.recoverDamage(healNumber, "w");
            }
        },
        "169": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I carefully dove among the rocks.",
                "I carefully dove among the rocks.",
                "I scratched my arm along a jagged rock.",
                "I grated my knee along the rough bottom."
            ],
            passSound: "Bubbles-01",
            failSound: "Drown-02",
            deathPhrase: "My head bounced off a rock and I blacked out.",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 1, "w"],
                [1, 3, 0, "w"]
            ]
        },
        "184": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I carefully crept among the rocks.",
                "I carefully crept among the rocks.",
                "I scratched myself a little climbing out among the rocks.",
                "I knocked my elbow on a porous stone climbing out."
            ],
            passSound: "Rocks-01",
            failSound: "Ouch-01",
            deathPhrase: "I knocked my head an on overhanging rock and blacked out for a second, falling!",
            deathPage: 178,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 2, 0, "w"],
                [1, 3, 0, "w"]
            ]
        },
        "248": {
            skill: null,
            difficulty: 0,
            resultPhrases: null,
            passSound: null,
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                if ('companions' in playerCharacter && playerCharacter.companions.length==1){
                    playerCharacter.companions.length = 0;
                    updateCompanionsList();
                    //showAlert("I felt Akara leave, and I would never see her again.");
                }
                
            }
        },
        "272": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["As I studied the RITUAL OF LIFE, I felt my body HEAL!"],
            passSound: "Suspence-Accents-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                //heal
                var healNumber = rollDice(1, 6, 5);
                playerCharacter.details.recoverDamage(healNumber, "s");
                healNumber = rollDice(1, 6, 5);
                playerCharacter.details.recoverDamage(healNumber, "w");
                healNumber = rollDice(1, 4, 1);
                playerCharacter.details.recoverDamage(healNumber, "m");

            }
        },
        "273": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["My heart thudded, then stopped beating entirely."],
            passSound: "Suspence-Accents-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                //add flag "ritualOfDeath"
                playerCharacter.details.flags.push("undead");
            }
        },
        "274": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["A dark aura shimmered around me, then dissipated."],
            passSound: "Suspence-Accents-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                playerCharacter.details.armor = itemGenerator.createItemWithTemplate("forceShield");
            }
        },
        "275": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["My muscles surged with power and I clenched my teeth."],
            passSound: "Suspence-Accents-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                playerCharacter.details.strength = playerCharacter.details.strength + 4;
            }
        },
        "314": {
            skill: "Fitness",
            difficulty: 0,
            resultPhrases: ["I nimbly crawled out of the pit, avoiding the swarm!",
                "I nimbly crawled out of the pit, avoiding the swarm!",
                "I crawled out of the pit with just a few bites!",
                "My legs bled from countless bites and stings!"
            ],
            passSound: null,
            failSound: null,
            deathPhrase: "Countless stings weakened me, and I slid downward!",
            deathPage: 402,
            deathSound: null,
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 3, 0, "s"],
                [1, 4, 2, "w"]
            ]
        },
        "335": {
            skill: "Awareness",
            difficulty: 1,
            resultPhrases: ["I leapt at the last instant, avoiding the spikes!",
                "I leapt at the last instant, avoiding the spikes!",
                "I leapt at the last instant, avoiding the spikes!",
                "Sharpened spears sprung from the walls, plunging into me!"
            ],
            passSound: "Trap-Pass-01",
            failSound: "Trap-Hit",
            deathPhrase: "Spears erupted from the walls, impaling me!",
            deathPage: 336,
            deathSound: "Trap-Hit",
            damage: [
                [1, 0, 0, "s"],
                [1, 0, 0, "s"],
                [1, 0, 0, "w"],
                [1, 4, 2, "w"]
            ]
        },
        "386": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["I was pulled apart and reassembled elsewhere. My body was rejuvenated."],
            passSound: "Panting-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 6);
                playerCharacter.details.recoverDamage(healNumber, "s");
                healNumber = rollDice(1, 6, 6);
                playerCharacter.details.recoverDamage(healNumber, "w");
            }
        },
        "387": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["I was pulled apart and reassembled elsewhere. My body was rejuvenated."],
            passSound: "Panting-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 6);
                playerCharacter.details.recoverDamage(healNumber, "s");
                healNumber = rollDice(1, 6, 6);
                playerCharacter.details.recoverDamage(healNumber, "w");
            }
        },
        "371": {
            skill: null,
            difficulty: 0,
            resultPhrases: null,
            passSound: "",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                ////console.log(playerCharacter.companions);
                for (var i = 0;i<playerCharacter.companions.length;i++){
                    ////console.log("looping through companions!");
                    if (playerCharacter.companions[i][0]=="Zukath"){
                        ////console.log("Zukath Detected!");
                        playerCharacter.companions.length = 0;
                    }
                }
                updateCompanionsList();
            }
        },
         "379": {
            skill: null,
            difficulty: 0,
            resultPhrases: null,
            passSound: "",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                playerCharacter.companions.length = 0;
                updateCompanionsList();
            }
        },
        "409": {
            skill: null,
            difficulty: 0,
            resultPhrases: ["After taking a minute, my head felt clearer."],
            passSound: "Panting-01",
            failSound: null,
            deathPhrase: null,
            deathSound: null,
            damage: null,
            action: function(challenge) {
                var healNumber = rollDice(1, 6, 2);
                playerCharacter.details.recoverDamage(healNumber, "s");
            }
        }
        



        /*"999":{
        	skill:"awareness",
        	difficulty:0,
        	passPhrase:"Suddenly there were spikes and I dodged to avoid!",
        	passSound:null,
        	failPhrase:"Suddenly wooden spikes erupted from the bones and STUCK ME!",
        	failSound:null,
        	deathPhrase:"The last think I remember was the sound of the spike trap triggering.",
        	deathSound:null,
        	damage:[1,8,1,"w"]
        }*/
    }

    this.turnInitiative = [];
    var team1 = null;
    var team2 = null;
    var initiative = null;
    var heartbeat = null;
    var phaseLookup = ["Amazing", "Good", "Ordinary", "Marginal", "Marginal"];
    var view = document.getElementById("combatScreen");
    var charUI = document.getElementById("attackerImage");
    var phraseUI = document.getElementById("attackDescription");
    var soundUI = document.getElementById("onomatopoeia");
    var weaponUI = document.getElementById("weaponImage");
    var victimUI = document.getElementById("victimImage");
    var assessUI = document.getElementById("healthReport");
    
    var $combatTop = $('#charImageDiv');
    var $combatLeft = $('#weaponImageDiv');
    var $combatRight = $('#victimImageDiv');
    var $combatBottom = $('#healthReport');
    var $onomatopoeia = $('#onomatopoeia');
    var $attackDescription = $('#attackDescription');
    var $nextTurnButton = $("#nextTurnButton");
    var combatAnimating = false;

    $combatTop.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    $combatLeft.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    $combatRight.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    $combatBottom.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    $onomatopoeia.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    $attackDescription.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    $nextTurnButton.css("transform", "translate3d(0px,0px,0px);").css("-webkit-transform", "translate3d(0px,0px,0px);");
    
    
    var firstPhase = false;


    this.performChallenge = function(challenge) {

        if (challenge.skill) {
            var skillStat = characterGenerator.skillLookup[challenge.skill]['stat'];

            //If the character doesn't have the skill, they have to do it untrained
            var skillTarget;
            if (challenge.skill in playerCharacter.details.skills) {
                skillTarget = playerCharacter.details[skillStat] + playerCharacter.details.skills[challenge.skill].rank;
            } else {
                skillTarget = Math.floor(playerCharacter['details'][characterGenerator.skillLookup[challenge.skill]['stat']] / 2);
            }


            var result = playerCharacter.details.doSkillCheck(skillStat, skillTarget);
            if (!result) {
                var damageDice = challenge.damage[3];
                var damage = rollDice(damageDice[0], damageDice[1], damageDice[2]);
                var damResult = playerCharacter.details.takeDirectDamage(damage, damageDice[3]);

                audioPlayer.playAudio(challenge.failSound+",0,0");
                
                if (damResult == -1 || damResult == -2) {
                    if (challenge.resultPhrases!=null){
                    showAlert(challenge.deathPhrase);
                    }
                    changePage(challenge.deathPage);
                } else {
                    if (challenge.resultPhrases!=null){
                    showAlert(challenge.resultPhrases[3]);
                    }
                }


            } else {
                var damageDice = challenge.damage[result - 1];
                var damage = rollDice(damageDice[0], damageDice[1], damageDice[2]);
                var damResult = playerCharacter.details.takeDirectDamage(damage, damageDice[3]);


                audioPlayer.playAudio(challenge.passSound+",0,0");
                if (challenge.resultPhrases!=null){
                showAlert(challenge.resultPhrases[result - 1]);
                }
                if (damResult == -1 || damResult == -2) {
                    changePage(challenge.deathPage);
                }

            }
        } else {
            challenge.action(challenge);
            audioPlayer.playAudio(challenge.passSound+",0,0");
            if (challenge.resultPhrases!=null){
            showAlert(challenge.resultPhrases[0]);
            }
            if (damResult == -1 || damResult == -2) {
                changePage(challenge.deathPage);
            }

        }

    }

    this.updateCombatChoiceUI = function(actionCharacter){
                //console.log(actionCharacter);
                if (!actionCharacter||actionCharacter==undefined)
        
                //var combatChoice = combatChoiceLookup[3];
                combatChoiceTitle.innerHTML = "Your Turn!";
                if (combatHints.length>0){
                    combatChoiceHint.style.visibility = "visible";
                    combatChoiceHint.innerHTML = "<span class='red'>Hint: </span>"+combatHints.shift();
                } else {
                    combatChoiceHint.innerHTML = "";
                    combatChoiceHint.style.visibility = "hidden";
                }
                

                combatChoiceBody.innerHTML = actionCharacter.getCombatStatus();
                if (combatChoiceBody.innerHTML==""){
                    combatChoiceBody.style.display="none";
                } else {
                    combatChoiceBody.style.display="block";
                }
                var attackPhrase = "<li>basic unarmed attack</li>";
                
                
                if ('weapon' in actionCharacter && actionCharacter.weapon!=null && !('forceMelee' in actionCharacter.target)){
                    
                    combatB1.innerHTML = '<img class="combatChoiceIcon" src="images/'+actionCharacter.weapon.imageThumb+'"/> Attack';
                    attackPhrase = actionCharacter.weapon.attackPhrase;
                    if (actionCharacter.weapon.skill in playerCharacter.details.skills){
                        //// //console.log("Skilled");
                        attackPhrase = "<li style='' class='red'>bonus from "+characterGenerator.skillLookup[actionCharacter.weapon.skill]['name'].toLowerCase()+"</li>"+attackPhrase
                    }else {
                        //// //console.log("UnSKILLED");
                        //attackPhrase = "<li style=''>bonus from "+characterGenerator.skillLookup[actionCharacter.weapon.skill]['name'].toLowerCase()+"</li>"+attackPhrase
                    }
                } else {
                    //// //console.log("printing phrase");

                    if ('target' in actionCharacter && actionCharacter.target!=null){
                        if ('forceMelee' in actionCharacter.target){
                            attackPhrase = "<li style='' class=''>bugs are immune to weapons</li>"+attackPhrase;
                        }    
                    }
                     


                    if ('Brawling' in playerCharacter.details.skills){
                        //// //console.log("Skilled");
                        attackPhrase = "<li style='' class='red'>bonus from brawling</li>"+attackPhrase
                    }else {
                        //// //console.log("UnSKILLED");
                        //attackPhrase = "<li style='' class=''>bonus from brawling</li>"+attackPhrase
                    }
                    combatB1.innerHTML = '<img class="combatChoiceIcon" src="images/brawlingico_100.png"/> Slug';
                }
                //// //console.log(attackPhrase);
                //// //console.log("check if skill 1 is trained");
                //// //console.log("check if skill 2 is trained");
                combatChoiceL1.innerHTML = attackPhrase;

                

    }

    this.initiateCombat = function(thisTeam1, thisTeam2, skip) {
        firstPhase = true;
        combatSummary=[];

        $combatTop.css("opacity", "0");
        $combatLeft.css("opacity", "0");
        $combatRight.css("opacity", "0");
        $combatBottom.css("opacity", "0");
        $onomatopoeia.css("opacity", "0");
        $attackDescription.css("opacity", "0");
        $nextTurnButton.css("opacity", "0");

        if (!thisTeam1 || !thisTeam2) {
            return false;
        }

        team1 = thisTeam1;
        //// //console.log("TEAM "+team1);
        team2 = thisTeam2;

        var combatOver = false;

        //pick combat targets
        //// //console.log("picking combat targets");
        for (var i = 0; i < team1.length; i++) {
            team1[i].target = this.getTarget(team2);
            team1[i].team = team1;
            team1[i].opposingTeam = team2;
        }

        for (var i = 0; i < team2.length; i++) {
            team2[i].target = this.getTarget(team1);
            team2[i].team = team2;
            team2[i].opposingTeam = team1;
        }

        //// //console.log("TARGETS PICKED:");
        //// //console.log(team1);
        //// //console.log(team2);

        initiative = getInitiative();


        //set combat heartbeat

        heartbeat = window.setInterval(function() {
            nextTick(skip);
        }, 30);


    }


    var nextTick = function(skip) {
        var actionCharacter = null;
        var targetChar;

        //get the next character of the next phase
        if (initiative.length > 0) {
            if (initiative[0].length > 0) {
                //it's a character's action, remove the heartbeat timer
                clearInterval(heartbeat);
                heartbeat = null;
                //add click listener to combat screen
                if (!skip) {
                    $nextTurnButton.on('click', function(e) {
                        if (!combatAnimating) {
                            e.stopPropagation();

                            $combatScreen.off();

                            if (!heartbeat) {
                                heartbeat = window.setInterval(function() {
                                    nextTick(skip);
                                }, 10);
                            }
                        }


                    });
                } else {
                    if (!heartbeat) {
                        heartbeat = window.setInterval(function() {
                            nextTick(skip);
                        }, 10);
                    }
                }


                actionCharacter = initiative[0].pop();



                var attackResult;

                if (actionCharacter == playerCharacter.details&&!skip){
                   ////console.log("PLAYERCHARACTER'S TURN, SEND IN NULLS");
                animateCombatDisplay(actionCharacter, null, null, null, null, null, null);

                combatController.updateCombatChoiceUI(actionCharacter);

                var combatChoice = combatChoiceLookup[Math.floor(Math.random() * combatChoiceLookup.length)];
                //var combatChoice = combatChoiceLookup[3];
                var specialPhrase = "";
                if (combatChoice.skill in playerCharacter.details.skills){
                    specialPhrase = "<li style='' class='red'>bonus from "+combatChoice.skill.toLowerCase()+"</li>";
                } else {
                    //specialPhrase = "<li style='' class=''>bonus from "+combatChoice.skill.toLowerCase()+"</li>";
                }
                
                combatChoiceL2.innerHTML = specialPhrase+combatChoice.opportunityPhrase;
                combatB2.innerHTML = '<img class="combatChoiceIcon" src="'+combatChoice.image+'"/> '+combatChoice.name;
                combatB2.dataset.action = combatChoice.name;



                combatB1.onclick = function(e) {
                    combatB1.onclick = null;
                    doCombat(-1);
                };
                combatB2.onclick = function(e) {
                    combatB2.onclick = null;
                    doCombat(combatChoice);
 
                };

                } else{

                    doCombat(null);
                }


               
				
				function doCombat(special){

                ////console.log(">>>>>>>>>>>>>>");
                    //// //console.log(special);
				////console.log("DOING COMBAT");
                attackResult = actionCharacter.attack(special);
                ////console.log("ATTACK finished");
                targetChar = actionCharacter.target;
                ////console.log("Attack made! Attack result:");
                ////console.log(attackResult);

                if (attackResult.result == -1) {
                    nextTick(skip);
                } else if (attackResult.damage == -1 || attackResult.result == -3 ) {
                    ////console.log("the TARGET is DOWN");
                    ////console.log("the TARGET is DOWN...attacker needs a new target!");
                        if ('soundGrowl' in actionCharacter && !skip && (special==null||special==-1)) {
                            //// //console.log("PLAYING GROWL!!!");
                            audioPlayer.playAudio("0,0,0,"+actionCharacter.soundGrowl+",0");
                        }
                        //play body sound
                    if (!skip) {
                        var deadChar;
                        ////console.log("IDENTIFYING DEAD CHARACTER!");

                        if (attackResult.result != -3){
                            deadChar = actionCharacter.target
                            ////console.log(actionCharacter.target.sdesc);
                        } else {
                            deadChar = actionCharacter;
                        }
                        
                        if ('soundDeath' in deadChar){
                            audioPlayer.playAudio("0,0,0,0,"+deadChar.soundDeath, 600);    
                        } else {
                            audioPlayer.playAudio("0,0,0,0,Body-Fall-01", 600);    
                        }
                        

                    }
                    var consciousCharFound = false;
                    ////console.log("SEARCHING FOR CONSCIOUS CHARACTERS ON THE OPPOSING TEAM");
                    //UNLESS IT TUNRS BACK -3 then search the friendly team cause its technically the victims turn
                    
                    var searchTeam;
                    var attackingCharacter;
                    if (attackResult.result == -3){
                        searchTeam = actionCharacter.team;
                        attackingCharacter = actionCharacter.target
                    } else {
                        searchTeam = actionCharacter.opposingTeam;
                        attackingCharacter = actionCharacter;
                    }

                    for (var i = 0; i < searchTeam.length; i++) {
                        if (!searchTeam[i].unconscious) {
                            consciousCharFound = true;
                            ////console.log("NEW TARGET FOUND! Reassigned target to attackingChar");
                            ////console.log(attackingCharacter.sdesc);
                            attackingCharacter.target = searchTeam[i];
                        } else {

                        }
                    }

                    if (!consciousCharFound) {
                        //// //console.log("NO CONSCIOUS CHARACTERS FOUND!");
                        window.clearInterval(heartbeat);

                        setTimeout(function() {
                            animateCombatDisplay(actionCharacter, attackResult, false, false, actionCharacter.target, skip, special);
                        }, 10);
                        //// //console.log("ACTIONCHARACTER: "+actionCharacter);
                        if (!skip) {
                            $nextTurnButton.off();
                            $nextTurnButton.html("Continue");
                            $nextTurnButton.on('click', { actionCharacter : actionCharacter, team1:team1} , function(e) {
                                //// //console.log("ACTIONCHARACTER: "+actionCharacter);
                                e.stopPropagation();
                                var clickEvent = e;
                                $nextTurnButton.off();
                                setTimeout(function() {
                                    var character;
                                    var actionCharacter = clickEvent.data.actionCharacter;
                                    if (attackResult.result == -3){
                                        //// //console.log("Character died countering!");
                                        //// //console.log(character);
                                        //// //console.log(actionCharacter);
                                        //// //console.log(actionCharacter.target);
                                        character = actionCharacter.target;
                                        //// //console.log(character);
                                    } else {
                                        character = actionCharacter;
                                    }

                                    //// //console.log(character);

                                    if (character.team == team1) {
                                        animateCombatDisplay(actionCharacter, attackResult, true, true, actionCharacter.target, skip, special);
                                    } else {
                                        animateCombatDisplay(actionCharacter, attackResult, true, false, actionCharacter.target, skip, special);
                                    }


                                }, 10);
                            });
                        } else {
                            updateSummary({
                                actionCharacter: actionCharacter,
                                attackResult: attackResult.result,
                                damage: attackResult.damage,
                                deathPhrase: attackResult.deathPhrase,
                                targetCharacter: actionCharacter.target
                            });
                            if (actionCharacter.team == team1) {
                                //// //console.log(">>>endCombatTransition 1");
                                endCombatTransition(true);
                            } else {
                                //// //console.log(">>>endCombatTransition 2");
                                endCombatTransition(false);
                            }



                        }




                    } else {
                        ////console.log("THERE IS A CONSCIOUS OPPONENT STILL!");
                        //Reassign target

                        setTimeout(function() {
                                animateCombatDisplay(actionCharacter, attackResult, false, false, targetChar, skip, special);
                            }, 10);    
                        
                        // if (attackResult.result == -2 ){
                        ////     //console.log("attacking character has no target, this shouldn't happen");
                        //     //doCombat(special);
                        // } else {
                        //     setTimeout(function() {
                        //         animateCombatDisplay(actionCharacter, attackResult, false, false, targetChar, skip, special);
                        //     }, 10);    
                        // }
                        

                    }
                } else {


                    //update combat screen with:
                    //attacker
                    //phrase
                    //image
                    //victim
                if ('soundGrowl' in actionCharacter && !skip && (special==null||special==-1)) {
                    //// //console.log("PLAYING GROWL!!!");
                    audioPlayer.playAudio("0,0,0,"+actionCharacter.soundGrowl+",0");
                }

                    setTimeout(function() {

                        animateCombatDisplay(actionCharacter, attackResult, false, false, actionCharacter.target, skip, special);
                    }, 10);


                }

                }


            } else {
                initiative.splice(0, 1);
                nextTick(skip);
            }
        } else {
            initiative = getInitiative();
            combatSummary.push("<br/>");
        }
    }

    this.executeRound = function() {
        this.getInitiative();
    }

    this.checkAggroPage = function(pageNumber) {
        if (pageNumber in aggroRoomLookup) {
            return true;
        } else {
            return false;
        }
    }

    this.getTarget = function(fromTeam) {
        ////console.log("Getting new target! from team:");
        ////console.log(fromTeam);
        return fromTeam[Math.floor(Math.random() * fromTeam.length)];
    }

    var animateCombatDisplay = function(actionCharacter, attackResult, endCombat, victory, targetCharacter, skip, special) {
        combatAnimating = true;
        ////console.log("ANIMATING COMBAT DISPLAY");
        ////console.log(combatChoiceScreen.className);
        ////console.log(special)
        if ((special!=null) && !skip&&!endCombat){
            ////console.log("ANIMATING OUT THE COMBAT DISPLAY!");
            $(combatChoiceScreen).attr("class", "fadeOutLeft noDelay").on(animEndEventName, function() {
                $(combatChoiceScreen).off(animEndEventName);
                combatChoiceScreen.className = "invisibleScreen";
                if (endCombat) {
                    ////console.log(">>>endCombatTransition 3");
                    endCombatTransition(victory);
                } else {
                    updateView({
                        actionCharacter: actionCharacter,
                        attackResult: attackResult.result,
                        damage: attackResult.damage,
                        deathPhrase: attackResult.deathPhrase,
                        targetCharacter: targetCharacter,
                        special:special
                    });
                }
            });
        } else {
            ////console.log("NORMAL ATTACK DETECTED");
            if (!firstPhase && !skip) {

                //JRR if the combat screen is visible, animate it away
                if (combatChoiceScreen.className!="invisibleScreen"){
                    $(combatChoiceScreen).attr("class", "actionSquare fadeOut noDelay").on(animEndEventName, function() {
                        $(combatChoiceScreen).off(animEndEventName);
                        combatChoiceScreen.className = "invisibleScreen";
                    });
                } else {

                }

                if (platform == "Android"||platform == "amazon-fireos"){
                    $(phaseScreen).attr("class", "fadeOutLeft noDelay").on(animEndEventName, function() {
                        $(phaseScreen).off(animEndEventName);
                        combatAnimating = false;
                        onFadeInDownComplete($(phaseScreen));
                        
                        setTimeout(function() {
                            ////console.log("PAGE ELEMENTS ANIMATED OUT");
                            if (attackResult!=null){
                                if (endCombat) {
                                   ////console.log(">>>endCombatTransition 4");
                                    endCombatTransition(victory);
                                } else {
                                    updateView({
                                        actionCharacter: actionCharacter,
                                        attackResult: attackResult.result,
                                        damage: attackResult.damage,
                                        deathPhrase: attackResult.deathPhrase,
                                        targetCharacter: targetCharacter,
                                        special:special
                                    });
                                }
                            } else {
                               ////console.log("REVEAL THE COMBAT CHOICE SCREEN");
                                $(combatChoiceScreen).attr("class", "fadeInRight noDelay visiblePage").on(animEndEventName, function() {
                                $(combatChoiceScreen).off(animEndEventName);
                                    combatChoiceScreen.className = "visiblePage";
                                });
                            }
                        }, 30);

                    });
                } else {

                    $combatTop.attr("class", "fadeOutLeft noDelay").on(animEndEventName, function() {
                        $combatTop.off(animEndEventName);
                    });


                    $combatLeft.attr("class", "fadeOutLeft noDelay").on(animEndEventName, function() {
                        $combatLeft.off(animEndEventName);
                        onFadeInLeftComplete($combatLeft);
                    });


                    $combatRight.attr("class", "fadeOutLeft noDelay").on(animEndEventName, function() {
                        $combatRight.off(animEndEventName);
                        onFadeInRightComplete($combatRight);
                    });

                    $onomatopoeia.attr("class", "fadeOutLeft noDelay").on(animEndEventName, function() {
                        $onomatopoeia.off(animEndEventName);
                        onFadeInRightComplete($onomatopoeia);
                    });


                    $attackDescription.attr("class", "bodyParagraph2 fadeOutLeft noDelay").on(animEndEventName, function() {
                        $attackDescription.off(animEndEventName);
                        onFadeInUpComplete($attackDescription);
                    });

                    $nextTurnButton.attr("class", "combatBtn genericBtn fadeOutLeft noDelay").on(animEndEventName, function() {
                        $nextTurnButton.off(animEndEventName);
                        onFadeInUpComplete($nextTurnButton);
                    });

                    ////console.log("ANIMATING OUT TRIGGER ELEMENT -- DOES IT TRIGGER ON COMPLETE?");
                    $combatBottom.attr("class", "bodyParagraph2 fadeOutLeft noDelay").on(animEndEventName, function() {
                        
                        $combatBottom.off(animEndEventName);
                        onFadeInUpComplete($combatBottom);

                        setTimeout(function() {
                            ////console.log("PAGE ELEMENTS ANIMATED OUT");
                            if (attackResult!=null){
                                if (endCombat) {
                                   ////console.log(">>>endCombatTransition 4");
                                    endCombatTransition(victory);
                                } else {
                                    updateView({
                                        actionCharacter: actionCharacter,
                                        attackResult: attackResult.result,
                                        damage: attackResult.damage,
                                        deathPhrase: attackResult.deathPhrase,
                                        targetCharacter: targetCharacter,
                                        special:special
                                    });
                                }
                            } else {
                               ////console.log("REVEAL THE COMBAT CHOICE SCREEN");
                                $(combatChoiceScreen).attr("class", "fadeInRight noDelay visiblePage").on(animEndEventName, function() {
                                $(combatChoiceScreen).off(animEndEventName);
                                    combatChoiceScreen.className = "visiblePage";
                                });
                            }
                        }, 30);

                    });

                }
            } else if (!skip&&attackResult!=null) {
                updateView({
                    actionCharacter: actionCharacter,
                    attackResult: attackResult.result,
                    damage: attackResult.damage,
                    deathPhrase: attackResult.deathPhrase,
                    targetCharacter: targetCharacter,
                    special:special
                });
            } else if (skip&&attackResult!=null){
                //This will fire if skip is true!
                ////console.log("SKIP THIS INTERFACE UPDATE!");
                updateSummary({
                    actionCharacter: actionCharacter,
                    attackResult: attackResult.result,
                    damage: attackResult.damage,
                    deathPhrase: attackResult.deathPhrase,
                    targetCharacter: targetCharacter
                });
            } else if (!skip && attackResult == null){
                //fade in the choice screen

                ////console.log("FINAL ELSE");
                ////console.log("REVEAL THE COMBAT CHOICE SCREEN");
                $(combatChoiceScreen).attr("class", "actionSquare fadeInRight noDelay visiblePage").on(animEndEventName, function() {
                $(combatChoiceScreen).off(animEndEventName);
                    combatChoiceScreen.className = "visiblePage";
                });
            }
        } 

    }


    var endCombatTransition = function(victory) {
        //// //console.log("endCombatTransition");
        hudAssess.innerHTML = "I" + playerCharacter.details.getAssess();

        $storyScreen.addClass("visiblePage");
        $combatScreen.off();
        var title = document.getElementById("endScreenTitle");
        var endCombatList = document.getElementById("endCombatList");
        var xpOwed = 0;
        var summaryContainer = document.getElementById('summaryContainer');
        endCombatList.innerHTML = "";
        summaryContainer.innerHTML = "";

        if (victory) {
            //valculate XP for bad guys
            for (var i = 0; i < team2.length; i++) {
                var character = team2[i];
                xpOwed = xpOwed + team2[i]['xpValue'];
            }
            //assign XP	
            for (var i = 0; i < team1.length; i++) {
                var character = team1[i];
                character.xp = character.xp + xpOwed;
            }
        }

        for (var i = 0; i < team1.length; i++) {
            var li = document.createElement('li');
            var div = document.createElement('div');
            var actionSquare = document.createElement('div');
            var charImg = document.createElement('img');
            var charDesc = document.createElement('p');
            var xpElem = document.createElement('p');
            
            var summaryParagraph = document.createElement('p');

            li.appendChild(div);
            div.appendChild(actionSquare);
            actionSquare.appendChild(charImg);
            div.appendChild(charDesc);
            div.appendChild(xpElem);
            endCombatList.appendChild(li);
            summaryContainer.appendChild(summaryParagraph)
            

            actionSquare.style.width = "100%";
            actionSquare.style.textAlign = "center";
            actionSquare.style.position = "absolute";
            

            summaryParagraph.style.paddingLeft = "5%";
            summaryParagraph.style.paddingRight = "5%";
            summaryParagraph.style.fontSize = "0.78em";
            summaryParagraph.id = "summary";

            if (!victory) {
                charImg.src = "images/" + team1[i]['imageDead'];
            } else {
                charImg.src = "images/" + team1[i]['imageTaunt'];
            }


            charImg.style.width = "94%";

            //charDesc.innerHTML = "I" + team1[i].getAssess();
            charDesc.innerHTML = "Tap to continue.";
            charDesc.className = "bodyParagraph2 pulse";
            charDesc.style.color = "black";
            charDesc.style.left = "5%"
            charDesc.style.maxWidth = "45%"
            charDesc.style.marginTop = "70px"
            /*
            xpElem.innerHTML = "+"+xpOwed+" XP";
            xpElem.className = "bodyParagraph1";
            xpElem.style.color = "black";
            xpElem.style.right = "6%";
            xpElem.style.marginTop = "23%";
            */
        }
        summaryParagraph.innerHTML = combatSummary.join("");
        if (victory) {
            title.innerHTML = "You Survived the Fight!";
        } else {
            title.innerHTML = "You Were Slain in the Fight!"
        }
        endCombatScreen.className = "fadeInRight";

        tableView.scrollTop = 0;

        endCombatScreen.onclick = function() {

            $nextTurnButton.html("Next Turn");
            playerCharacter.details.target = null;
            playerCharacter.details.team = null;
            playerCharacter.details.opposingTeam = null;


            if ('aiming' in playerCharacter.details){
                delete playerCharacter.details.aiming;
            }
            if ('dodging' in playerCharacter.details){
                delete playerCharacter.details.dodging;
            }
            if ('countering' in playerCharacter.details){
                delete playerCharacter.details.countering;
            }
            if ('baited' in playerCharacter.details){
                delete playerCharacter.details.baited;
            }

            combatChoiceBody.style.display = "none";
            


            currentPage[16] = [];
            endCombatScreen.className = "invisibleScreen";
            if (victory) {
                window.analytics.trackEvent('Combat Outcome', 'Victory', currentPage[1]);    
                swapElements(storyObject[pageLookup[currentPage[0]]['win']], pageLookup[currentPage[0]]['win']);
                //// //console.log("fadeOut CLASS JUST ADDED BY CLICK!");
                $combatScreen.addClass( "fadeOut" ).on( animEndEventName, function() {
                            $combatScreen.off( animEndEventName );
                            $combatScreen.attr("class","invisibleScreen");
                                $tableView.attr("class","fadeIn visiblePage").on( animEndEventName, function() {
                                    $tableView.off( animEndEventName );
                                    $tableView.attr("class","visiblePage");
                                    animating = false;
                                } );
                        } );
            } else {
                window.analytics.trackEvent('Combat Outcome', 'Defeat', currentPage[1]);    
                 swapElements(storyObject[pageLookup[currentPage[0]]['lose']], pageLookup[currentPage[0]]['lose']);
                $combatScreen.addClass( "fadeOut" ).on( animEndEventName, function() {
                            $combatScreen.off( animEndEventName );
                            $combatScreen.attr("class","invisibleScreen");
                                $tableView.attr("class","fadeIn visiblePage").on( animEndEventName, function() {
                                    $tableView.off( animEndEventName );
                                    $tableView.attr("class","visiblePage");
                                    animating = false;
                                } );
                        } );


            }

        }

        // playerCharacter.details.target.target = null;
        // playerCharacter.details.target = null;
        // playerCharacter.details.team = null;
        // playerCharacter.details.opposingTeam = null;					currentPage[16] = [];
        // updatePageList();


    };

    var updateSummary = function(data) {
        
        if (data.deathPhrase != undefined) {
            ////console.log(data.deathPhrase);
            ////console.log("About to capitalize first letter of deathPhrase...");
            combatSummary.push("<br/>" + capitalizeFirstLetter(data.deathPhrase));
        } else {
            ////console.log(data.attackResult);
            ////console.log("About to capitalize first letter of attackResult...");
            if (typeof data.attackResult == "string"){
                combatSummary.push("<br/>" + capitalizeFirstLetter(data.attackResult));
            }
            
        }
        ////console.log("finished updating summary");
    }

    var updateView = function(data) {
        updateSummary(data);
        //var view = document.getElementById("combatScreen");
        //var charUI = document.getElementById("attackerImage");

////console.log("UPDATING VIEW");
////console.log(data);

        if ((data.actionCharacter != playerCharacter.details)&&!('countering' in data.actionCharacter.target)){
           assessUI.innerHTML = "I" + data.targetCharacter.getAssess();
        } else if ('countering' in data.actionCharacter.target){
            assessUI.innerHTML = data.actionCharacter.pronoun + data.actionCharacter.getAssess();
        } else {
            assessUI.innerHTML = data.targetCharacter.pronoun + data.targetCharacter.getAssess();
        }

        if (data.damage > 0 || data.damage < 0) {
            if ('countering' in data.actionCharacter.target){
                soundUI.innerHTML = "BIFF! CRACK!";
                audioPlayer.playAudio("Punch-01", 300);
            } else if (data.special==null||data.special==-1)
             {
                if ('weapon' in data.actionCharacter) {
                    if ((data.actionCharacter.weapon != null) && !('forceMelee' in data.actionCharacter.target)) {
                        soundUI.innerHTML = data.actionCharacter.weapon.hitCallout;
                        audioPlayer.playAudio(data.actionCharacter.weapon.hitSound, 300);
                    } else {
                        soundUI.innerHTML = "THWACK!";
                        audioPlayer.playAudio("Punch-01", 300);
                    }
                } else {
                    soundUI.innerHTML = "THWACK!";
                    audioPlayer.playAudio("Punch-01", 300);
                }
            }
            

        } else

        {

            if (data.special==null||data.special==-1) {
               
                if ('weapon' in data.actionCharacter) {
                    if ((data.actionCharacter.weapon != null) && !('forceMelee' in data.actionCharacter.target)) {
                        soundUI.innerHTML = data.actionCharacter.weapon.missCallout;
                        audioPlayer.playAudio(data.actionCharacter.weapon.missSound, 600);
                    } else {
                        soundUI.innerHTML = "WHOOSH!";
                        audioPlayer.playAudio("Swing-01", 600);
                    }
                } else {
                    soundUI.innerHTML = "WHOOSH!";
                    audioPlayer.playAudio("Swing-01", 600);
                }

            } else {
                
            }

        }

        //// //console.log(data.special);
        if (data.special!=null&&data.special!=-1){
            //// //console.log(">>>>>>> SPECIAL, DRAWING CHAR UI");
                ////console.log(data);
                ////console.log("Checking special in data");
                
                switch (data.special.name){
                        case "Counter":
                            charUI.src = "images/combat_tiles/slice32_32.png";
                            soundUI.innerHTML = "*INHALE*";
                            assessUI.innerHTML = "...time seems to slow down..."
                            audioPlayer.playAudio("Heartbeat-01", 600);
                        break;
                        case "Dodge":
                            charUI.src = "images/combat_tiles/slice19_19.png";
                            soundUI.innerHTML = "*INHALE*";
                            assessUI.innerHTML = "...time seems to slow down..."
                            audioPlayer.playAudio("Heartbeat-01", 600);
                        break;
                        case "Kick":
                            charUI.src = "images/combat_tiles/slice28_28.png";
                            //// //console.log("SETTING KICK IMAGE");
                            audioPlayer.playAudio("0,0,0,"+data.actionCharacter.soundGrowl+",0");
                            if (data.damage > 0 || data.damage == -1){
                                soundUI.innerHTML = "CRUNNNCH!";
                                audioPlayer.playAudio("Punch-01", 600);    
                            } else {
                                soundUI.innerHTML = "WHOOOOSH!"
                                audioPlayer.playAudio("Swing-01", 1000);
                            }

                        break;
                        case "Jab":
                            charUI.src = "images/combat_tiles/slice01_01.png";
                            audioPlayer.playAudio("0,0,0,"+data.actionCharacter.soundGrowl+",0");
                            if (data.damage > 0 || data.damage == -1){
                                soundUI.innerHTML = "WHACK!";
                                audioPlayer.playAudio("Punch-02", 600);    
                            } else {
                                soundUI.innerHTML = "WHIFF!"
                                audioPlayer.playAudio("Swing-01", 1000);
                            }

                        break;
                        case "Bait":
                            charUI.src = "images/combat_tiles/slice01_01.png";
                            audioPlayer.playAudio("0,0,0,"+data.actionCharacter.soundGrowl+",0");
                             if (data.damage > 0 || data.damage == -1){
                                soundUI.innerHTML = "SSSSLAP!";
                                 audioPlayer.playAudio("Punch-02", 600);    
                             } else {
                                soundUI.innerHTML = "SHWISH!";
                                 audioPlayer.playAudio("Swing-01", 1000);
                             }
                        break;
                        case "Aim":
                            charUI.src = "images/combat_tiles/slice32_32.png";
                            soundUI.innerHTML = "*INHALE*";
                            assessUI.innerHTML = "...time seems to slow down..."
                             audioPlayer.playAudio("Heartbeat-01", 600);
                        break;
                        default:
                            if ('weapon' in data.actionCharacter && data.actionCharacter == playerCharacter.details) {
                                if (data.actionCharacter.weapon != null && !('forceMelee' in data.actionCharacter.target)) {
                                    charUI.src = "images/" + data.actionCharacter.weapon.imagePlayerAttack;
                                } else {
                                    charUI.src = "images/" + data.actionCharacter.imageAttack;
                                }
                            } else {
                                charUI.src = "images/" + data.actionCharacter.imageAttack;
                            }
                        break;
                    }
                
        } else {
            //// //console.log(">>>>>>> NO SPECIAL, DRAWING CHAR UI");
            if ('weapon' in data.actionCharacter && data.actionCharacter == playerCharacter.details) {
                //// //console.log("CHAR IS PLAYER AND HAS WEAPON");
                //// //console.log(data.actionCharacter.weapon);
                //// //console.log(!('forceMelee' in data.actionCharacter.target));
                if (data.actionCharacter.weapon != null && !('forceMelee' in data.actionCharacter.target)) {
                    //// //console.log("WEAPON IS NOT NULL, AND ACTIONCHAR TARGET DOESNT FORCEMELEE");
                    charUI.src = "images/" + data.actionCharacter.weapon.imagePlayerAttack;
                    //// //console.log("WEAPON ATTACK SHOWN");
                } else {
                    //// //console.log("WEAPON IS NULL OR ACTIONCHAR TARGET IS FORCEMELEE");
                    charUI.src = "images/" + data.actionCharacter.imageAttack;
                    //// //console.log("CHARACTER ATTACK SHOWN");
                }
            } else {
                //// //console.log("NO WEAPON OR NOT PLAYER CHAR");
                charUI.src = "images/" + data.actionCharacter.imageAttack;
            //// //console.log("CHARACTER ATTACK SHOWN");
            }
        }

        /*if ('weapon' in data.actionCharacter){
        	if (data.actionCharacter.weapon!=null){
        		weaponUI.src = "images/"+data.actionCharacter.weapon.imageThumb;		
        	} else {
        		weaponUI.src = "images/fist.png";	
        	}
        } else {
        	weaponUI.src = "images/fist.png";	
        }*/

        

        if (data.deathPhrase != undefined) {

            phraseUI.innerHTML = data.deathPhrase;
        } else {
            phraseUI.innerHTML = data.attackResult;
        }


        if (data.damage > 1&&data.attackResult!=-3) {
            if ('countering' in data.actionCharacter.target){
                victimUI.src = "images/combat_tiles/slice_counter.png";    
            } else {
                victimUI.src = "images/" + data.actionCharacter.target.imageHurt;    
            }
        } else if (data.damage == -1) {
            if (data.attackResult==-3){
                victimUI.src = "images/" + data.actionCharacter.imageDead;
            } else {
                victimUI.src = "images/" + data.actionCharacter.target.imageDead;
            }            
        } else {
            victimUI.src = "images/" + data.actionCharacter.target.imageTaunt;
        } 

        

        //var soundUI = document.getElementById("onomatopoeia");
        //var weaponUI = document.getElementById("weaponImage");
        //var victimUI = document.getElementById("combatScreen");


        if (firstPhase) {

            if (platform == "Android"||platform == "amazon-fireos"){
                $(phaseScreen).css("opacity", "0");

            }

            $combatTop.css("opacity", "1");
            $combatLeft.css("opacity", "1");
            $combatRight.css("opacity", "1");
            $combatBottom.css("opacity", "1");
            $onomatopoeia.css("opacity", "1");
            $attackDescription.css("opacity", "1");
            $nextTurnButton.css("opacity", "1");
            
            combatAnimating = true;
            firstPhase = false;
        }
setTimeout(function() {
        if (platform == "Android"||platform == "amazon-fireos"){
            $(phaseScreen).attr("class", "fadeInRight").on(animEndEventName, function() {
                $(phaseScreen).off(animEndEventName);
                combatAnimating = false;
                //onFadeInDownComplete($(phaseScreen));
                //console.log("nextTurnButton has finished animating");
                if ((data.actionCharacter.target == playerCharacter.details)&&(data.attackResult!=-3)&&(data.damage > 0 || data.damage < 0)){
                    updateHUD();    
                }
                

            });
        } else {
        $combatTop.attr("class", "fadeInRight").on(animEndEventName, function() {
            $combatTop.off(animEndEventName);
            onFadeInDownComplete($combatTop);
            $combatTop.attr("class", "gpu")
        });
        $combatLeft.attr("class", "fadeInRight").on(animEndEventName, function() {
            $combatLeft.off(animEndEventName);
            onFadeInDownComplete($combatLeft);
            $combatLeft.attr("class", "gpu")
        });
        $combatRight.attr("class", "fadeInRight").on(animEndEventName, function() {
            $combatRight.off(animEndEventName);
            onFadeInDownComplete($combatRight);
            $combatRight.attr("class", "gpu");
        });
        $combatBottom.attr("class", "bodyParagraph2 fadeInRight").on(animEndEventName, function() {
            $combatBottom.off(animEndEventName);
            combatAnimating = false;
            onFadeInDownComplete($combatBottom);
            $combatBottom.attr("class", "gpu bodyParagraph2")

        });
        $attackDescription.attr("class", "bodyParagraph2 fadeInRight").on(animEndEventName, function() {
            $attackDescription.off(animEndEventName);
            onFadeInDownComplete($attackDescription);
            $attackDescription.attr("class", "gpu bodyParagraph2")
        });
        $nextTurnButton.attr("class", "combatBtn genericBtn fadeInRight").on(animEndEventName, function() {
            $nextTurnButton.off(animEndEventName);
            onFadeInDownComplete($nextTurnButton);
            $nextTurnButton.attr("class", "gpu pulse combatBtn genericBtn");
            //console.log("nextTurnButton has finished animating");
            if ((data.actionCharacter.target == playerCharacter.details)&&(data.attackResult!=-3)&&(data.damage > 0 || data.damage < 0)){
                updateHUD();    
            }
        });
        $onomatopoeia.attr("class", "fadeInRight").on(animEndEventName, function() {
            $onomatopoeia.off(animEndEventName);
            onFadeInDownComplete($onomatopoeia);
        });
        }
}, 30);



    }

    var getInitiative = function() {
        //iterate through all characters, come up with round queue
        var initiativeArray = [
            [],
            [],
            [],
            [],
            []
        ];
        //// //console.log("LOGGING TEAM 1 FROM GETINITIATIVE");
        //// //console.log(team1);

        for (var i = 0; i < team1.length; i++) {
            var character = team1[i];
            //// //console.log(character);
            var actionCheck = character.doActionCheck();
            for (var j = 0; j < character.actionsNum; j++) {
                if (actionCheck + j - 1 < 5) {

                    if (j > 1 && (actionCheck + j - 1 == 4)) {

                    } else {
                        initiativeArray[actionCheck + j - 1].push(character);
                    }

                }
            }
        }

        for (var i = 0; i < team2.length; i++) {
            var character = team2[i];

            var actionCheck = character.doActionCheck();
            for (var j = 0; j < character.actionsNum; j++) {
                if (actionCheck + j - 1 < 5) {
                    initiativeArray[actionCheck + j - 1].push(character);
                }
            }
        }

        initiativeArray[3] = initiativeArray[3].concat(initiativeArray[4]);
        initiativeArray.splice(4, 1);

        return initiativeArray;
    }

}