function itemGenerator () {

	var itemTemplates = {
		"stick1": {
			name:"a heavy branch of wood",
			skill:"meleeBludgeon",
			itemType:"weapon",
			acc:0,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,1,"s"],[1,4,0,"w"],[1,4,1,"w"]],
			actions:3,
			hide:1,
			mass:2,
			avail:"any",
			cost:10,
			words:["bludgeons","bludgeon"],
			material:"wood"
		},
		"stick2": {
			name:"a knobby-ended, twisted branch",
			skill:"meleeBludgeon",
			itemType:"weapon",
			acc:1,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,1,"s"],[1,4,0,"w"],[1,4,1,"w"]],
			actions:3,
			hide:1,
			mass:2,
			avail:"any",
			cost:10,
			words:["bludgeons","bludgeon"],
			material:"wood"
		},
		"wastelandFood1": {
			name:"a stash of preserved food",
			itemType:"food",
			PL:0,
			mass:1,
			avail:"any",
			cost:10,
			material:"debris",
			imageThumb: "item20thumb.png",
			imageFull: "item20full.png"
		},
		"wastelandFood2": {
			name:"an old bottle of warm water",
			itemType:"water",
			PL:0,
			mass:1,
			avail:"any",
			cost:10,
			material:"water",
			imageThumb: "item16thumb.png",
			imageFull: "item16full.png"
		},
		"tireIron":{
			name:"An Old Tire Iron",
			skill:"meleeBludgeon",
			itemType:"weapon",
			acc:0,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,1,"s"],[1,4,0,"w"],[1,4,1,"w"]],
			actions:3,
			hide:1,
			mass:2,
			avail:"any",
			cost:25,
			words:["bludgeons","bludgeon"],
			material:"metal",
			imageThumb: "item7thumb.png",
			imageFull:"item7full.png",
			hitCallout:"CRAAACK!",
			missCallout:"WOOOOSH!",
			hitSound:"Right Hook-SoundBible.com-1406389182",
			missSound:"Woosh-Mark_DiAngelo-4778593"
		},
		"baseballBat":{
			name:"A Scarred Old Baseball Bat",
			skill:"meleeBludgeon",
			itemType:"weapon",
			acc:0,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,1,"s"],[1,4,0,"w"],[1,4,1,"w"]],
			actions:3,
			hide:1,
			mass:2,
			avail:"any",
			cost:25,
			words:["bludgeons","bludgeon"],
			material:"metal",
			imageThumb: "item6thumb.png",
			imageFull:"item6thumb.png",
			hitCallout:"CRAAACK!",
			missCallout:"WOOOOSH!",
			hitSound:"Right Hook-SoundBible.com-1406389182",
			missSound:"Woosh-Mark_DiAngelo-4778593"
		},
		"a blue-handled rock hammer":{
			name:"A Blue-Gripped Metal Rock Hammer",
			skill:"Brawling",
			itemType:"weapon",
			acc:-3,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,2,3,"w"],[1,3,3,"w"],[1,3,5,"w"]],
			actions:3,
			hide:1,
			mass:2,
			avail:"any",
			cost:25,
			words:["bludgeons","bludgeon"],
			material:"metal",
			imageThumb: "item2thumb_50.png",
			imageFull:"item2thumb.png",
			imagePlayerAttack:"combat_tiles/slice07_07.png",
			hitCallout:"CRAAACK!",
			missCallout:"WOOOOSH!",
			hitSound:"Hammer-02",
			missSound:"Swing-02",
			useSound:"Hammer-01",
			attackPhrase:"<li>familiar weapon bonus</li>",
		},
		"an ornately jeweled dagger":{
			name:"an ornately jeweled dagger",
			skill:"Brawling",
			itemType:"weapon",
			acc:-1,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,2,2,"w"],[1,3,2,"w"],[1,3,4,"w"]],
			actions:3,
			hide:1,
			mass:2,
			avail:"any",
			cost:225,
			words:["pierces","pierce"],
			material:"metal",
			imageThumb: "item25thumb_50.png",
			imageFull:"item25thumb.png",
			imagePlayerAttack:"combat_tiles/slice45_45.png",
			hitCallout:"GASSSHH!",
			missCallout:"ZOOOSH!",
			hitSound:"Ornate-01",
			missSound:"Ornate-02",
			useSound:"Ornate-03",
			attackPhrase:"<li>steals enemy life</li>",
			vampiric:true
		},
		"natureFood1": {
			name:"a handful of withered berries",
			itemType:"food",
			PL:0,
			mass:1,
			avail:"any",
			cost:10,
			material:"organic"
		},

		"natureFood2": {
			name:"a bruised crabapple",
			itemType:"food",
			PL:0,
			mass:1,
			avail:"any",
			cost:10,
			material:"organic"
		},
		"leatherCoat":{
			name:"a heavy leather jacket",
			desc:"This jacket is old but tough.",
			itemType:"armor",
			PL:5,
			skill:null,
			actionPenalty:0,
			toughness:"o",
			armor:[[1,6,-3],[1,4,-3],[1,4,-2]],
			hide:+3,
			mass:5,
			avail:"any",
			cost:500,
			material:"leather"
		},
		"ballisticVest":{
			name:"a stained ballistic vest",
			desc:"The vest is bulky and stained.",
			itemType:"armor",
			PL:5,
			skill:null,
			actionPenalty:0,
			toughness:"o",
			armor:[[1,6,-3],[1,6,-2],[1,4,-2]],
			hide:+3,
			mass:5,
			avail:"con",
			cost:600,
			material:"cloth"
		},
		"assaultGear":{
			name:"bulky assault armor",
			desc:"This assault gear has ceramic plating.",
			itemType:"armor",
			PL:5,
			skill:"combat",
			actionPenalty:3,
			toughness:"o",
			armor:[[1,6,-1],[1,6,-1],[1,6,-1]],
			hide:0,
			mass:10,
			avail:"con",
			cost:600,
			material:"cloth"
		},
		"dogHide": {
			name:"pale hide",
			desc:"This tough hide is scarred from past fights.",
			itemType:"armor",
			PL:1,
			skill:"naturalArmor",
			actionPenalty:0,
			toughness:"o",
			armor:[[1,4,-2],[0,0,0],[0,0,0]],
			hide:0,
			mass:10,
			avail:"any",
			cost:20,
			material:"cloth"
		},
		"combatKnife": {
			name:"A Serrated Combat Knife",
			skill:"meleeBlade",
			itemType:"weapon",
			acc:0,
			PL:5,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,1,"w"],[1,4,2,"w"],[1,4,3,"w"]],
			actions:4,
			hide:3,
			mass:1,
			avail:"any",
			cost:35,
			words:["stabs","stab"],
			material:"metal"
		},
		"machete": {
			name:"A Crude Machete",
			skill:"meleeBlade",
			itemType:"weapon",
			acc:0,
			PL:5,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,0,"w"],[1,6,0,"w"],[1,6,2,"w"]],
			actions:3,
			hide:2,
			mass:1,
			avail:"any",
			cost:100,
			words:["stabs","stab"],
			material:"metal",
			imageThumb: "item8thumb.png",
			imageFull:"item8full.png"
		},
		"axe": {
			name:"A Heavy Axe",
			skill:"meleeBlade",
			itemType:"weapon",
			acc:1,
			PL:4,
			range:"melee",
			type:["li","o"],
			damage:[[1,6,1,"w"],[1,6,2,"w"],[1,4,1,"m"]],
			actions:2,
			hide:null,
			mass:5,
			avail:"any",
			cost:100,
			words:["chops","chop"],
			material:"wood"
		},
		"dogTeeth": {
			name:"A Canine Maw",
			skill:"meleeNatural",
			itemType:"weapon",
			acc:0,
			PL:1,
			range:"melee",
			type:["li","o"],
			damage:[[1,3,0,"w"],[1,3,1,"w"],[1,4,2,"w"]],
			actions:3,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["claws","swipe"],
			material:"bone",
			imageThumb: "claw.png",
			imageFull:"claw.png",
			hitCallout:"SHHLICK!",
			missCallout:"SHHHWOOSH!",
			hitSound:"Claw-02",
			missSound:"Swing-02"
		},
		"spiderTeeth": {
			name:"A Spider Fang",
			skill:"meleeNatural",
			itemType:"weapon",
			acc:-2,
			PL:1,
			range:"melee",
			type:["li","o"],
			damage:[[1,2,0,"s"],[1,2,1,"s"],[1,4,0,"s"]],
			actions:2,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["INJECTS","bite"],
			material:"bone",
			imageThumb: "fangs.png",
			imageFull:"fangs.png",
			hitCallout:"PIINNNCH!",
			missCallout:"CHITTTTER!",
			hitSound:"Spider-04",
			missSound:"Spider-02"
		},
		"zealot smother": {
			name:"Crushing Fingers",
			skill:"meleeNatural",
			itemType:"weapon",
			acc:0,
			PL:1,
			range:"melee",
			type:["li","o"],
			damage:[[1,1,0,"s"],[1,2,0,"w"],[1,3,0,"s"]],
			actions:3,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["wrenches","grasp"],
			material:"bone",
			imageThumb: "claw.png",
			imageFull:"claw.png",
			hitCallout:"CRUNNNCH!",
			missCallout:"WOOOSSH!",
			hitSound:"Zealot-Attack-03",
			missSound:"Swing-01"
		},
		"zealot choke": {
			name:"Crushing Fingers",
			skill:"meleeNatural",
			itemType:"weapon",
			acc:0,
			PL:1,
			range:"melee",
			type:["li","o"],
			damage:[[1,3,0,"s"],[1,4,0,"s"],[1,6,0,"s"]],
			actions:3,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["chokes","lunge"],
			material:"bone",
			imageThumb: "claw.png",
			imageFull:"claw.png",
			hitCallout:"FLAP CHOKE!",
			missCallout:"FLA-FLAP!",
			hitSound:"Zealot-Attack-02",
			missSound:"Zealot-Attack-Miss-02"
		},
		"centibeast glands": {
			name:"A Pale, Sticky Gland",
			skill:"Awareness",
			itemType:"weapon",
			acc:-2,
			PL:1,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,0,"s"],[1,4,1,"s"],[1,3,2,"s"]],
			actions:2,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["MIND WHIPS","mind whip"],
			material:"organic",
			imageThumb: "fangs.png",
			imageFull:"fangs.png",
			hitCallout:"rRRrrRR!",
			missCallout:"HMMMMM!",
			hitSound:"Centibeast-Blast-01",
			missSound:"Centibeast-Miss-01"
		},
		"blowgun": {
			name:"A Long Reed Blowgun",
			skill:"Marksmanship",
			itemType:"weapon",
			acc:0,
			PL:1,
			range:[6,12,50],
			type:["en","o"],
			damage:[[1,2,0,"w"],[1,2,1,"w"],[1,3,1,"w"]],
			actions:2,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["shoots","blown dart"],
			material:"wood",
			imageThumb: "lightning.png",
			imageFull:"lightning.png",
			hitCallout:"FFT THUNK!",
			missCallout:"FFT ZIP!",
			hitSound:"Zealot-Attack-01",
			missSound:"Zealot-Attack-Miss-01"
		},
		"lightningSigil": {
			name:"A Black-Inked Lightning Sigil",
			skill:"Awareness",
			itemType:"weapon",
			acc:0,
			PL:1,
			range:[6,12,50],
			type:["en","o"],
			damage:[[1,4,1,"s"],[1,4,0,"w"],[1,4,3,"w"]],
			actions:2,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["electrocutes","vicious arc"],
			material:"energy",
			imageThumb: "lightning.png",
			imageFull:"lightning.png",
			hitCallout:"ZAP ZAPP!",
			missCallout:"BZZT BZZ!",
			hitSound:"Lightning-01",
			missSound:"Lightning-02"
		},
		"lightningSigilEnraged": {
			name:"A Black-Inked Lightning Sigil",
			skill:"Awareness",
			itemType:"weapon",
			acc:1,
			PL:1,
			range:[6,12,50],
			type:["en","o"],
			damage:[[1,4,2,"s"],[1,4,1,"w"],[1,4,3,"w"]],
			actions:2,
			hide:null,
			mass:0,
			avail:"any",
			cost:100,
			words:["angrily electrocutes","enraged arc"],
			material:"energy",
			imageThumb: "lightning.png",
			imageFull:"lightning.png",
			hitCallout:"ZAP ZAPP!",
			missCallout:"BZZT BZZ!",
			hitSound:"Lightning-01",
			missSound:"Lightning-02"
		},
		"tentacles":{
			name:"a mass of rubbery tentacles",
			skill:"meleeNatural",
			itemType:"weapon",
			acc:0,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,4,2,"s"],[1,4,2,"w"],[1,5,2,"w"]],
			actions:2,
			hide:1,
			mass:2,
			avail:"any",
			cost:25,
			words:["whips","whip"],
			material:"organic",
			imageThumb: "item2thumb.png",
			imageFull:"item2thumb.png",
			imagePlayerAttack:"combat_tiles/slice07_07.png",
			hitCallout:"WH-SLAP!",
			missCallout:"WH-WHIP!",
			hitSound:"Antonio-Attack-Hit-01",
			missSound:"Antonio-Attack-Miss-01",
			useSound:"Hammer-01",
			attackPhrase:"<li>familiar weapon bonus</li>",
		},
		"a massive metal blade":{
			name:"A heavy, rusted metal blade",
			skill:"Brawling",
			itemType:"weapon",
			acc:0,
			PL:0,
			range:"melee",
			type:["li","o"],
			damage:[[1,5,3,"w"],[1,6,3,"w"],[1,6,5,"w"]],
			actions:1,
			hide:1,
			mass:2,
			avail:"any",
			cost:25,
			words:["cleaves","cleave"],
			material:"metal",
			imageThumb: "item2thumb.png",
			imageFull:"item2thumb.png",
			imagePlayerAttack:"combat_tiles/slice07_07.png",
			hitCallout:"CHOPPPP!",
			missCallout:"CRASH!",
			hitSound:"Jackal-Blade-01",
			missSound:"Jackal-Blade-02",
			useSound:"Hammer-01",
			attackPhrase:"<li>familiar weapon bonus</li>",
		},
		"my .44 magnum": {
			name:"a .44 Magnum",
			skill:"Marksmanship",
			itemType:"weapon",
			acc:-3,
			PL:4,
			range:[6,12,50],
			type:["hi","o"],
			damage:[[1,3,3,"w"],[1,5,4,"w"],[1,4,3,"m"]],
			actions:3,
			clipSize:6,
			bullets:6,
			clipCost:15,
			hide:2,
			mass:1,
			avail:"com",
			cost:250,
			words:["blasts","blast"],
			material:"metal",
			imageThumb: "item12thumb_50.png",
			imageFull:"item12thumb.png",
			imagePlayerAttack:"combat_tiles/slice13_13.png",
			hitCallout:"BLAM! SPLAT!",
			missCallout:"BLAM! ZZIP!",
			hitSound:"Magnum-02",
			missSound:"Magnum-03",
			useSound:"Revolver-01",
			attackPhrase:"<li>familiar weapon bonus</li><li>can do mortal damage</li>",
		},
		"forceShield":{
			name:"dark aura",
			desc:"The shield of force wavered subtly in the light.",
			itemType:"armor",
			PL:5,
			skill:null,
			actionPenalty:0,
			toughness:"o",
			armor:[[1,2,0],[1,2,0],[1,2,0]],
			//armor:[[1,2,10],[1,2,10],[1,2,10]],
			hide:+4,
			mass:0,
			avail:"res",
			cost:2000,
			material:"energy"
		},
		"a nutty chocolate bar": {
			name:"a nutty chocolate bar",
			itemType:"food",
			PL:0,
			mass:1,
			avail:"any",
			cost:10,
			material:"organic",
			imageThumb: "item20thumb.png",
			imageFull: "item20full.png",
			useSound:"Crunching-01",
			action: function(){
				 var healNumber = rollDice(1,6,5);
                    playerCharacter.details.recoverDamage(healNumber,"s");
                    healNumber = rollDice(1,4,3);
                    playerCharacter.details.recoverDamage(healNumber,"w");
                    audioPlayer.playAudio("0,"+this.useSound+",0");
                    removeInventoryItem(this.name);
                    
                    
			}
		},"a vial of dark liquid": {
			name:"a vial of dark liquid",
			itemType:"food",
			PL:0,
			mass:1,
			avail:"any",
			cost:100,
			material:"organic",
			imageThumb: "item21thumb.png",
			imageFull: "item21full.png",
			useSound:"Gulp-01",
			action: function(){
				 var healNumber = rollDice(1,6,5);
                    playerCharacter.details.recoverDamage(healNumber,"s");
                    healNumber = rollDice(1,4,3);
                    playerCharacter.details.recoverDamage(healNumber,"w");
                    audioPlayer.playAudio("0,"+this.useSound+",0");
                    removeInventoryItem(this.name);
                    
			}
		}
	};

	this.createItemWithTemplate = function(persona){
		var newItem = new item();
		var template = null

		if (persona in itemTemplates){
			template = itemTemplates[persona]
		} else {
			console.log("item template not recognized...");
			return false;
		}

		for (var key in template) {
    		if (template.hasOwnProperty(key)) {
        		newItem[key] = template[key];
    		}
		}

		return newItem;
	}

}