function pageGenerator() {

	var weatherSkill = 14;
	var encounterSkill = 14;
	var weather = 0;
	var forageSkill = 14;

	var resourceLookup = {
		"natureWood":["stick1", "stick2"],
		"natureFood":["natureFood1","natureFood2"],
		"wastelandFood":["wastelandFood1","wastelandFood2"],
		"wastelandWeapon":["baseballBat","tireIron"],
	}

	var biomeLookup = {
		"gasWastes":{
			adjectives:["Corroded","Chemical-Scorched","Prickly-Shrubbed", "Hazy","Fume-Reeking","Gas-Scoured"],
			nouns:["Waste","Wasteland","Barrens","Scrublands","Landscape","Thornland","Badlands","Wilderness"],
			captions:[],
			images:["7.png","36.png","45.png","49.png"],
			forageables:["wastelandWeapon","wastelandFood"],
			creatures:["marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler"],
		 	maxCorrosion:[3] //0: moderate, 1:toxic, 2: corrosive, 3: super-corrosive

		},
		"woods":{
			adjectives:["Gloomy, Pine-Spotted","Prickly-Shrubbed", "Dark, Leaf-Covered","Breezy, Forested"],
			nouns:["Grove","Gully","Ridge","Hill","Thicket","Creek","Woods","Forest"],
			captions:[],
			forageables:["natureWood","natureFood"],
			creatures:["marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalBrawler",
					"marginalBrawler",
					"marginalBrawler"],
		 	maxCorrosion:[1] //0: moderate, 1:toxic, 2: corrosive, 3: super-corrosive
		},
		"highway":{
			adjectives:["Gloomy, Car-Littered","Tarnished", "Corroded","Blockaded", "Skeleton-Strewn"],
			nouns:["Hilly Road","Curved Road","Intersection","Country Road","Underpass","Highway Bridge","Roadway","Stretch of Road"],
			captions:[],
			forageables:["metal"],
			creatures:["marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalDog",
					"marginalBrawler",
					"marginalBrawler",
					"scavenger",
					"scavenger",
					"raider",
					"raider"],
		 	maxCorrosion:[1] //0: moderate, 1:toxic, 2: corrosive, 3: super-corrosive
		},
		"suburb":{
			adjectives:["Abandoned", "Forgotten","Empty", "Garbage-Strewn","Overgrown"],
			nouns:["Lot","Suburb","Street","Neighbourhood","Subdivision","Gated Community","Gas Station","Downtown", "Little Street"],
			captions:[],
			forageables:["electronic parts", "metal","food"],
			creatures:["marginalDog",
					"marginalDog",
					"marginalDog",
					"scavenger",
					"scavenger",
					"scavenger",
					"raider",
					"raider",
					"militia",
					"militia"],
		 	maxCorrosion:[1] //0: moderate, 1:toxic, 2: corrosive, 3: super-corrosive
		}

	}

	
	this.createPageWithDifficultyInBiome = function(difficulty, biome){
		var newPage = [];
		var randomAdjective = null;
		var randomNoun = null;
		var title = this.generateTitle(biome);
		var weatherCheck = skillCheck(0, weatherSkill);
		var atmosphere;
		var creatures = [];
		var items = [];

		if (weatherCheck > 3){
			//weather gets worse
			weather++;
			if (weather>3){weather=3};

			if (weather>biomeLookup[biome].maxCorrosion){weather=biomeLookup[biome].maxCorrosion}
			//console.log("The weather gets worse!");


		} else if (weatherCheck==3){
			//weather stays the same
			//console.log("The weather stays the same.");

		} else {
			//weather improves
			weather--;
			if (weather < 0){weather=0};
			//console.log("The weather gets a bit better.");
		}

		atmosphere = weather;
		console.log(title);
		var weatherPhrase = ["breathable","toxic","corrosive","super corrosive"];
		var creatureReport = "The wastes stretched on around me, desolate."

		console.log("The atmosphere is "+ weatherPhrase[weather]);

		var encounterCheck = skillCheck(difficulty, encounterSkill);
		if (encounterCheck > 3){
			creatures = [this.generateMobsForBiome(biome)];
			console.log("There is a creature here: "+creatures[0].sdesc);
			creatureReport = "I could hear something moving. I wasn't alone."
		} else {

		}

		var forageCheck = skillCheck(difficulty, forageSkill);
		if (forageCheck < 3){
			items = [this.generateItemForBiome(biome)];
			console.log("There is an item here: "+items[0].name);
		}
		console.log("");

		var choices = [["Simple Choice","Stagger on through the wastes",null,-1,null,false]];
		var characters = [];
		var objects = []
		
		
		if (creatures.length>0){
			var creature = creatures[0];
			var newChar = ["random",creature.sdesc+" came running at me!","Grrr!",creature.image,creature.image, creature];
			characters.push(newChar);
		}

		if (items.length>0){
			var item = items[0];
			var newItem = [item.name,"I found "+item.name+" there.","I found this old thing abandoned in the wasteland.",item.imageThumb,item.imageFull];
			objects.push(newItem);
		}

		newPage[0]=-1;
		newPage[1]=title;
		newPage[2]="The air was "+ weatherPhrase[weather]
		newPage[3]=creatureReport;
		newPage.push(0,11.9,311.95,35.25,15.85,84.9,154.95,50.63,119.8,315.3,157.65,51.2); 
		newPage.push(characters,objects,choices,[]);

		newPageImage = this.getImageForBiome(biome);
		console.log("New page image: "+newPageImage);

		newPage.push("","",newPageImage,"","","");

console.log(newPage);
		return newPage
	}

	this.getImageForBiome = function(biome){
		var imagesForBiome = biomeLookup[biome]['images'];
		return imagesForBiome[Math.floor(Math.random() * imagesForBiome.length)];
	}

	this.generateMobsForBiome = function(biome){
		var mobRoll = Math.floor(Math.random() * 9) + 0;
		return characterGenerator.createCharWithTemplate(biomeLookup[biome]['creatures'][mobRoll]);
	}

	this.generateItemForBiome = function(biome){
		var biomeItemTypes = biomeLookup[biome]['forageables'];
		var randomItemType = biomeItemTypes[Math.floor(Math.random() * biomeItemTypes.length)];
		var itemsForType = resourceLookup[randomItemType];
		var randomItem = itemsForType[Math.floor(Math.random() * itemsForType.length)];
		return itemGenerator.createItemWithTemplate(randomItem);

	}


	this.generateTitle = function(biome){
	var adjectives = biomeLookup[biome]['adjectives'];
	var nouns = biomeLookup[biome]['nouns'];

	adjectives = adjectives[Math.floor(Math.random() * adjectives.length)];
	nouns = nouns[Math.floor(Math.random() * nouns.length)];

	return "A "+adjectives+" "+nouns;
	}




}